unit Umain1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,System.UIConsts,
  {$IFDEF MSWINDOWS}
  Winapi.ShellAPI, Winapi.Windows,
  {$ENDIF}

  // used by NativeMap ---------------------------------------------------------
  FMX.uecgeoLocalise,
  FMX.uecNativeMapControl,FMX.uecNativeShape,FMX.uecNativePlace,
  FMX.uecMapUtil,FMX.uecGraphics, FMX.uecNativeMiniMap,FMX.uecNativePlaceLayer,
     // for recalculate a route interactively
  FMX.uecEditNativeLine,
    // for the label triangles animated
  FMX.uecNativeLabelLayer,

  // ---------------------------------------------------------------------------

  FMX.Edit, FMX.ListBox, FMX.Objects, FMX.StdCtrls, FMX.Controls.Presentation{$IFDEF XE7_OR_HIGHER}, FMX.Controls.Presentation{$ENDIF};

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ckPanoramio: TCheckBox;
    pnLatLng: TPanel;
    LatLng: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    RouteStart: TEdit;
    RouteEnd: TEdit;
    AddRoute: TButton;
    GroupBox2: TGroupBox;
    DefaultMarker: TButton;
    MarkerImage: TButton;
    Traffic: TCheckBox;
    GroupBox3: TGroupBox;
    cbMaps: TComboBox;
    InfoRoute: TLabel;
    LoadMap: TButton;
    SaveMap: TButton;
    OpenDialog: TOpenDialog;
    ClearMap: TButton;
    SaveDialog: TSaveDialog;
    MarkerPOI: TButton;
    ckMiniMap: TCheckBox;
    Lines: TGroupBox;
    btLines: TButton;
    btPoly: TButton;
    btNone: TButton;
    lbInfosize: TLabel;
    ArcDial1: TArcDial;
    pnMap: TPanel;
    pnInfo: TPanel;
    Label3: TLabel;
    GroupBox4: TGroupBox;
    rbResto: TRadioButton;
    rbStore: TRadioButton;
    btFindPlaces: TButton;
    btAbort: TButton;
    GroupBox5: TGroupBox;
    edAdress: TEdit;
    website: TLabel;
    PermaLink: TGroupBox;
    cbPermaLink: TComboBox;
    AddLink: TButton;
    UtfGeography: TCheckBox;
    rbNone: TRadioButton;
    ckLoupe: TCheckBox;
    map: TECNativeMap;
    pnNativeMap: TPanel;
    procedure ckPanoramioClick(Sender: TObject);
    procedure mapMapMouseMove(sender: TObject; const Lat, Lng: Double);
    procedure mapRoutePath(sender: TObject; const params: string;
      routePath: TECRoutePath);
    procedure AddRouteClick(Sender: TObject);
    procedure mapPanoramioClick(sender: TObject; const Item: TECShape;
      const ownerId, ownerName, PhotoId, PhotoDate, PhotoTitle, PhotoUrl,
      copyright: string);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DefaultMarkerClick(Sender: TObject);
    procedure MarkerImageClick(Sender: TObject);
    procedure TrafficClick(Sender: TObject);

    procedure cbMapsClick(Sender: TObject);
    procedure LoadMapClick(Sender: TObject);
    procedure ClearMapClick(Sender: TObject);
    procedure SaveMapClick(Sender: TObject);
    procedure MarkerPOIClick(Sender: TObject);
    procedure ckMiniMapChange(Sender: TObject);

    procedure btLinesClick(Sender: TObject);

    procedure mapMapClick(sender: TObject; const Lat, Lng: Double);
    procedure mapShapeClick(sender: TObject; const item: TECShape);
    procedure ArcDial1Change(Sender: TObject);
    procedure btAbortClick(Sender: TObject);
    procedure btFindPlacesClick(Sender: TObject);
    procedure ECGeoSearch(Sender: TObject);
    procedure edAdressKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure websiteClick(Sender: TObject);
    procedure AddLinkClick(Sender: TObject);
    procedure cbPermaLinkClick(Sender: TObject);
    procedure UtfGeographyClick(Sender: TObject);
    procedure rbNoneClick(Sender: TObject);
    procedure ckLoupeChange(Sender: TObject);
    procedure mapLoad(sender: TObject; const GroupName: string;
      const FinishLoading: Boolean);
    procedure mapBeforeUrl(sender: TObject; var Url: string);
 

  private
    { Dclarations prives }
   FMiniMap : TECNativeMiniMap;


  // recalculate a route interactively   see uecEditNativeLine.pas
  FecNativeLineToRoute: TecNativeLineToRoute;

  // labels layer see uecNativeLabelLayer
   FLabelLayer : TecNativeLabelLayer;

   FSelectedShape : TECShape;

   FInfoWindowShapes : TECShapes;

   FUTFLayer : TECNativeUTFLayer;

   FPlacesLayer : TECNativePlaceLayer;

   procedure  Editshape (const Value:boolean);
   procedure  doPathChange(sender : TObject);


   procedure doOnLineMouseOver(sender: TObject; const item: TECShape);

   procedure doOnShapeMove(sender: TObject; const item: TECShape;var cancel: boolean);

   procedure doEndAnimationMove(sender : TObject);

   procedure doNumDrawPOI(const canvas:TECCanvas;var r:TRect;item:TECShape) ;
   procedure doOwnerDrawPOI(const canvas:TECCanvas;var Rect:TRect;item:TECshape) ;
   procedure doFontPOI(const canvas:TECCanvas;item:TECshape) ;

   procedure OpenInfoWindow(const content:string;const Latitude,Longitude:single);

   procedure GetArcGisPlacesTile(var TileFilename:string;const x,y,z:integer);

   procedure GetUTFTile(var TileFilename:string;const x,y,z:integer);
   procedure doOnOverUTFData(sender : TObject);
   procedure doOnOutUTFData(sender : TObject);

   procedure doOnPlaceClick(sender : TECShape);
   procedure doOnMoveTriangle(sender : TObject;const Item : TECShape; var cancel:boolean);
   procedure doOnDrawAllRoute(sender : TObject);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}



function GetRandomColor:TAlphaColor;
begin

 TAlphaColorRec(result).R := random(255);
 TAlphaColorRec(result).G := random(255);
 TAlphaColorRec(result).B := random(255);
 TAlphaColorRec(result).A := 255;

end;

// ============ FORM ===========================================================



procedure TForm1.FormCreate(Sender: TObject);
begin


 // class for edit line
  FecNativeLineToRoute          := TecNativeLineToRoute.create;

 // use your Bing Map Key => http://msdn.microsoft.com/fr-fr/library/ff428642.aspx
 Map.BingKey := 'ArHKANdOJkF3qiLETYcxAJSpT1lpG1sPR-jDLu7DHr0DZVFvky30AehdYHMhWoy4';

 btNone.isPressed := true;

 // local cache for tiles
 map.LocalCache := ExtractfilePath(ParamStr(0))+'cache';

 // create minimap
 FMiniMap := TECNativeMiniMap.create(map);

 ckLoupe.visible := ckMiniMap.IsChecked;

 // re draw after basic draw
 map.group['pois'].Pois.OnAfterDraw := doNumDrawPOI;
 // self draw pois
 map.group['pois'].Pois.OnOwnerDraw := doOwnerDrawPOI;



 // group infowindows
 FInfoWindowShapes := map.Group['mywindows'];
 FInfoWindowShapes.Zindex := 20;


 // default infowindow
 FInfoWindowShapes.InfoWindows.add(0,0,'');
 FInfoWindowShapes.InfoWindows[0].zindex := 100;
 FInfoWindowShapes.InfoWindows[0].Width  := 200;


 // support UTFGrid Layer see http://www.mapbox.com/developers/utfgrid/

 FUTFLayer := TECNativeUTFLayer.create(map,'mapbox.geography',GetUTFTile);

 FUTFLayer.OnMouseOver := doOnOverUTFData;
 FUTFLayer.OnMouseOut  := doOnOutUTFData;

 FUTFLayer.Shapes.Zindex := 2;

 

 // search Layer

 FPlacesLayer               := TECNativePlaceLayer.create(map,'PLACES_LAYER');
 FPlacesLayer.Shapes.zindex := 2;
 FPlacesLayer.OnPLaceClick  := doOnPlaceClick;
 FPlacesLayer.LocalCache    := map.LocalCache;

 // label triangles animated
 FLabelLayer := TecNativeLabelLayer.create(map,'labels');
 FLabelLayer.visible := true;

 ckMiniMapChange(nil);

 map.setCenter(43.2332,0.0736);

end;



procedure TForm1.FormDestroy(Sender: TObject);
begin
 FecNativeLineToRoute.free;
 FMiniMap.free;
 FUTFLayer.free;
 FPlacesLayer.free;
 FLabelLayer.Free;

end;



procedure TForm1.ArcDial1Change(Sender: TObject);
begin
 map.RotationAngle := ArcDial1.value;
end;

// =============================================================================




// =========  Maps ======================================================


// select map tiles



procedure TForm1.cbMapsClick(Sender: TObject);
begin
 // use same tileserver than map
 FMiniMap.TileServer := tsNone;

 map.RemoveOverlayTiles;

 case cbMaps.ItemIndex of
  0 :  map.TileServer := tsOpenMapQuest;
  1 :  begin
        map.TileServer        := tsOpenMapQuestSat;
        FMiniMap.TileServer := tsOpenMapQuest;
       end;
  2 :  map.TileServer := tsOSM;

  3 :  map.TileServer := tsOpenCycleMap;
  4 :  map.TileServer := tsOPNV;

  5 :  map.tileServer := tsArcGisWorldTopoMap;
  6 :  map.tileServer := tsArcGisWorldStreetMap;
  7 :  begin
          map.tileServer        := tsArcGisWorldImagery;
          // use different minimap
          FMiniMap.TileServer := tsArcGisWorldStreetMap;
       end;
   8 : begin

        map.tileServer        := tsArcGisWorldImagery;
        // add overlay tiles for places
        map.AddOverlayTiles(GetArcGisPlacesTile,'World_Places_Tile');
          // use different minimap
        FMiniMap.TileServer := tsArcGisWorldStreetMap;

   end;

   9 : begin

        map.TileServer      := tsBingRoad;
        FMiniMap.TileServer := tsBingRoad;

       end;

   10 : begin

         map.TileServer      := tsBingAerial;
         FMiniMap.TileServer := tsBingRoad;

       end;

   11 : begin

         map.TileServer      := tsBingAerialLabels;
         FMiniMap.TileServer := tsBingRoad;

       end;
  12 : begin

        map.TileServer      := tsHereNormal;
        FMiniMap.TileServer := tsHereNormal;

       end;
  13 : begin

        map.TileServer      := tsHereTerrain;
        FMiniMap.TileServer := tsHereTerrain;

       end;

  14 : begin

        map.TileServer      := tsHereMobile;
        FMiniMap.TileServer := tsHereMobile;

       end;
  15 : begin

        map.TileServer      := tsHereHiRes;
        FMiniMap.TileServer := tsHereHiRes;

       end;
 16 : begin

        map.TileServer      := tsHereTransit;
        FMiniMap.TileServer := tsHereTransit;

       end;
 17 : begin

        map.TileServer      := tsHereTruck;
        FMiniMap.TileServer := tsHereTruck;

       end;
 18 : begin

        map.TileServer      := tsHereTraffic;
        FMiniMap.TileServer := tsHereTraffic;

       end;

 19 : begin

         map.TileServer      := tsBingAerialLabels;
         map.AddOverlayTileServer(tsHereFlow);
         FMiniMap.TileServer := tsBingRoad;

       end;

end;

end;


procedure TForm1.cbPermaLinkClick(Sender: TObject);
begin
 if cbPermaLink.ItemIndex<0 then exit;

 map.Url := cbPermaLink.Items[cbPermaLink.ItemIndex];
end;

procedure TForm1.GetArcGisPlacesTile(var TileFilename:string;const x,y,z:integer);
begin
 TileFilename := format('http://services.arcgisonline.com/ArcGIS/rest/services/Reference/World_Boundaries_and_Places/MapServer/tile/%d/%d/%d.png',[z,y,x]);
 end;


// load data map
procedure TForm1.LoadMapClick(Sender: TObject);
begin
 if OpenDialog.Execute then
  map.LoadFromfile(OpenDialog.FileName);
end;


// save data map
procedure TForm1.SaveMapClick(Sender: TObject);
begin
 if SaveDialog.Execute then
  map.SaveToFile(SaveDialog.FileName);
end;


// CLear
procedure TForm1.ClearMapClick(Sender: TObject);
begin

  FecNativeLineToRoute.Line := nil;

  map.Shapes.clear;  // clear default group

  // clear also Search layer

  FPlacesLayer.Shapes.clear;

  // clear routes

  map.Group['routes'].Clear;

  // clear pois

  map.group['pois'].Clear;

  // clear LabelLayer

  FLabelLayer.Clear;

end;


// show/hide minimap
procedure TForm1.ckLoupeChange(Sender: TObject);
begin
 FMiniMap.Loupe := ckLoupe.IsChecked;
end;

procedure TForm1.ckMiniMapChange(Sender: TObject);
begin
 if ckMiniMap.IsChecked then
  FMiniMap.Map := Map
 else
  FMiniMap.Map := nil;

  ckLoupe.visible := ckMiniMap.IsChecked;
end;


procedure TForm1.mapMapMouseMove(sender: TObject; const Lat, Lng: Double);
begin
 LatLng.Text := DoubleToStrDigit(Lat,4)+' - '+DoubleTOStrdigit(Lng,4);
end;





// =============================================================================



// ====== support UTFGrid see http://www.mapbox.com/developers/utfgrid/  ======


// connexion utf geography tiles

// http://a.tiles.mapbox.com/v3/mapbox.geography-class/4/7/7.grid.json for see data tile

procedure TForm1.GetUTFTile(var TileFilename:string;const x,y,z:integer);
begin
 TileFilename := format('http://%s.tiles.mapbox.com/v3/mapbox.geography-class/%d/%d/%d.grid.json',
                         [Char(Ord('a') + random(3)),z,x,y]);
end;


// OnOver country

// FUTFLayer.Data['admin']     country name
// FUTFLayer.Data['flag_png']  country flag png base64 encoded

procedure TForm1.doOnOverUTFData(sender : TObject);
begin

  if not assigned(FUTFLayer.Shapes.InfoWindows[0]) then exit;


  FUTFLayer.Shapes.InfoWindows[0].Content :='<img src="data:image/png;base64,'+FUTFLayer.data['flag_png']+'" width="80" height="40">'+
                                             '<h3>'+FUTFLayer.data['admin']+'</h3>';

  FUTFLayer.Shapes.InfoWindows[0].SetPosition(map.MouseLatLng.Lat,map.MouseLatLng.Lng);
  FUTFLayer.Shapes.InfoWindows[0].Visible := true;

end;



procedure TForm1.doOnOutUTFData(sender : TObject);
begin
 if assigned(FUTFLayer.Shapes.InfoWindows[0]) then

  FUTFLayer.Shapes.InfoWindows[0].Visible := false;
end;


procedure TForm1.UtfGeographyClick(Sender: TObject);
begin

 if  not UtfGeography.IsChecked then
 begin

   map.Zoom    := 4;
   map.MaxZoom := 8;

   FUTFLayer.Shapes.InfoWindows.Clear;

  FUTFLayer.Shapes.InfoWindows.add(-10,-100,'');
  FUTFLayer.Shapes.InfoWindows[0].zindex := 100;
  FUTFLayer.Shapes.InfoWindows[0].color  := claBeige;
  FUTFLayer.Shapes.InfoWindows[0].Width  := 110;
  FUTFLayer.Shapes.InfoWindows[0].ContentCenter := true;

   FUTFLayer.visible := true;

 end else begin
           FUTFLayer.visible := false;
           map.MaxZoom := 18;
          end;

end;



// =========== SEARCH ============================================================


(*
  Classic Search with TECGeoLocalise

  not used in this demo, TECNativeLayer used instead

*)
procedure TForm1.btAbortClick(Sender: TObject);
begin
 map.Geolocalise.AbortPlaceSearch;
end;

procedure TForm1.btFindPlacesClick(Sender: TObject);
var
  Tags: string;
begin

  btFindPlaces.enabled := false;

  btAbort.visible := true;



  map.Geolocalise.Places.latitude := map.latitude;
  map.Geolocalise.Places.longitude := map.longitude;

  map.Geolocalise.Places.Radius := 1000; // 1000 meters

  if rbStore.ischecked then
    Tags := 'node[shop=*]'
  else if rbResto.ischecked then
    Tags := 'node[amenity=restaurant]';





  map.Geolocalise.Places.Search(Tags);




end;

procedure TForm1.ECGeoSearch(Sender: TObject);
var
  i, max: Integer;
  iMarker: Integer;
  icon, types, names: string;
  GroupFind : TECShapes;
begin


  btFindPlaces.enabled :=  true;

  btabort.visible := false;

  WaitFor(50);

  if map.Geolocalise.Places.Status <> 'OK' then
    exit;


  GroupFind := map.Group['FIND'];

  GroupFind.Clear;

  max := map.Geolocalise.Places.results.count - 1;

  if max<0 then
  begin
    showMessage('Zero result');
    exit;
  end;



  for i := 0 to max do
  begin

    types := map.Geolocalise.Places.results[i].result['types'];
    names := map.Geolocalise.Places.results[i].result['name'];

    if names = '' then
      names := 'unknown';

    iMarker := GroupFind.Markers.add(map.Geolocalise.Places.results[i].latitude,
      map.Geolocalise.Places.results[i].longitude);


      if pos('restaurant', types) > 0 then
        icon := 'http://google-maps-icons.googlecode.com/files/restaurant.png'
      else if pos('doctor', types) > 0 then
        icon := 'http://google-maps-icons.googlecode.com/files/doctor.png'
      else
        icon := 'http://google-maps-icons.googlecode.com/files/supermarket.png';

      GroupFind.Markers[iMarker].Clickable := true;
      GroupFind.Markers[iMarker].filename := icon;
      GroupFind.Markers[iMarker].hint := names;
      // map.Markers[iMarker].IconSize   := Point(37,32);

    end;

  end;

  // === end Search with TECGeoLocalise not used in this demo ==================


// activate/deactivate TECNativeLayer
procedure TForm1.rbNoneClick(Sender: TObject);
begin

 if not (Sender is TRadioButton) then exit;

 case TRadioButton(Sender).tag of

  0 : FPlacesLayer.Visible := false;

  1 : begin

       FPlacesLayer.Visible := true;
       FPlacesLayer.MarkerFilename := 'http://google-maps-icons.googlecode.com/files/restaurant.png';
       FPlacesLayer.Search  := 'node[amenity=restaurant]';


      end;

  2 : begin

       FPlacesLayer.Visible := true;
       FPlacesLayer.MarkerFilename := 'http://google-maps-icons.googlecode.com/files/supermarket.png';
       FPlacesLayer.Search  := 'node[shop=*]';
      end;

 end;

end;


// event click on place shape
procedure TForm1.doOnPlaceClick(sender : TECshape);
var
    pResult : TECPlaceResult;
    r,
    n,
    Content : string;
    i       : integer;
begin

   // here Sender and Sender.Item are allway assigned


   if (Sender.item) is TECPlaceResult then

   pResult :=TECPlaceResult(Sender.item)

   else

   exit;


   content := '<img src="'+UrlStaticGoogleStreetView(Sender.Latitude,Sender.Longitude,300,200)+'"><br><br>';

   for i:=0 to pResult.CountResult-1 do
   begin



    n := pResult.NameResult[i];
    r := pResult.Result[n];
    if length(n)<9 then
     n := n+'<tab="65">';

    content := content+'<b>'+n+'</b>: '+r+'<br>';

   end;


   if FPlacesLayer.Shapes.InfoWindows.Count=0 then
   begin
     FPlacesLayer.Shapes.InfoWindows.add(0,0,'');
     FPlacesLayer.Shapes.InfoWindows[0].zindex := 100;
     FPlacesLayer.Shapes.InfoWindows[0].width  := 320;
   end;

   FPlacesLayer.Shapes.InfoWindows[0].content := Content;
   FPlacesLayer.Shapes.InfoWindows[0].SetPosition(Sender.Latitude,Sender.Longitude);
   FPlacesLayer.Shapes.InfoWindows[0].Visible := true;

   // show on top
   FPlacesLayer.Shapes.zindex := Map.TopGroupZIndex;





end;




// =============================================================================


// ============ Adress =========================================================

procedure TForm1.edAdressKeyUp(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin

 if Key=13 then
 begin
  Map.Address := edAdress.Text;
 end;

end;

// =============================================================================










// ======== Lines / Polygones ==================================================


procedure TForm1.btLinesClick(Sender: TObject);
begin

 if sender<>btLines then
  btLines.IsPressed := false;

 if sender<>btPoly then
  btPoly.IsPressed  := false;

 if sender<>btNone then
  btNone.IsPressed  := false;


 EditShape(false);
 FSelectedshape := nil;


end;

procedure TForm1.mapShapeClick(sender: TObject; const item: TECShape);
var s:string;
begin
 (*
 if (item is TECShapePolygone) then
  OpenInfoWindow(TECShapePolygone(item).description,item.latitude,item.longitude);

  exit;
 *)

 if assigned(FSelectedshape) and (FSelectedshape is TECshapeLine) then
  TECshapeLine(FSelectedshape).Editable := false;


 // select Line or Polygone ?
 if  (item is TECShapeLine) and (item.Group.Name<>'routes')then
 begin

   FSelectedShape := Item;

   btNone.isPressed := false;

   if item is TECShapePolygone then
      btPoly.IsPressed := true
    else
      btLines.IsPressed := true;

    EditShape(true);

 end

 else   // no line or polygone

 begin
     FSelectedShape    := nil;
     btNone.IsPressed  := true;
     btPoly.IsPressed  := false;
     btLines.IsPressed := false;
 end;

 if (btNone.isPressed) or (not btLines.IsPressed  and not btPoly.IsPressed ) then
 begin


  s := '<img src="'+UrlStaticGoogleStreetView(item.latitude,item.longitude,300,200)+'"><br><br>'+
       '<b>Latitude <tab="70">: </b>'+DoubleToStrDigit(item.latitude,4)+'<br><b>Longitude <tab="70">: </b>'+DoubleToStrDigit(item.longitude,4)+'<br><br>'+
       map.Geolocalise.Reverse(item.latitude,item.longitude) ;

  if Map.Zoom<18 then
  begin
    s := s+'<br><br><a href="#'+inttostr(18)+'/'+doubleToStrDigit(item.Latitude,6)+'/'+DoubleToStrDigit(item.Longitude,6)+'"><font hcolor=FF0000 >ZoomToStreet</font></a>';
  end;

  OpenInfoWindow(s,item.latitude,item.longitude);


 end;


end;



// call by clickink on link "Zoom to street" in InfoWindow
 // close InfoWindow if exists
procedure TForm1.mapBeforeUrl(sender: TObject; var Url: string);
begin
  if (FInfoWindowShapes.InfoWindows.count > 0) then
  FInfoWindowShapes.InfoWindows[0].Visible := false;
end;



procedure TForm1.mapLoad(sender: TObject; const GroupName: string;
  const FinishLoading: Boolean);
begin
 if assigned(sender) and (sender is TECShapes) then
  TECShapes(sender).fitBounds;
end;

procedure TForm1.mapMapClick(sender: TObject; const Lat, Lng: Double);
begin


 if not assigned(FSelectedshape) then
 begin

   if btPoly.IsPressed then

    FSelectedshape := map.add(nsPolygon,Lat,Lng)

   else

   if btLines.IsPressed then

    FSelectedshape := map.add(nsLine,Lat,Lng);

    if not assigned( FSelectedShape ) then exit;

    FSelectedShape.color      := GetRandomColor;
    FSelectedShape.HoverColor := GetHighlightColorBy(FSelectedShape.color,32);

    if btPoly.IsPressed then
    TECShapePolygone(FSelectedShape).FillColor := GetshadowColorBy(FSelectedShape.color,32);

  EditShape(true);
 


 end else begin

         // if not key CTRL then add point
         if not (KeyIsDown(vkcontrol))  then
         begin


           if btPoly.IsPressed then

            TECshapePolygone(FSelectedshape).Add(Lat,Lng)
            else
            TECshapeLine(FSelectedshape).Add(Lat,Lng) ;

         end

         else  // if CTRL Pressed then move Shape

           FSelectedshape.SetPosition(lat,lng);

        end;

end;




procedure TForm1.Editshape (const Value:boolean);
begin

 pnInfo.Visible := false;

 if not assigned(FSelectedshape) then exit;

 if FSelectedshape is TECShapePolygone then
  TECshapePolygone(FSelectedshape).Editable := value
  else
  if FSelectedshape is TECShapeLine then
   TECshapeLine(FSelectedshape).Editable := value
  else
   exit;


  if value then
  begin

    pnInfo.Visible := true;

    TECshapeLine(FSelectedShape).OnShapePathChange := doPathChange;

    // update infos perimeter / area
    doPathChange(FSelectedShape);


  end;

end;



procedure TForm1.doPathChange(sender : TObject);
begin


  if sender is TECShapePolygone then

  lbInfoSize.text := 'Perimeter : '+doubleToStrDigit(TECShapePolygone(sender).Distance,4 )+' Km '#13#10'Area : '+doubleToStrDigit(TECShapePolygone(sender).Area,4 )+' Km'

  else

  if sender is TECShapeLine then

  lbInfoSize.text := 'Distance : '+doubleToStrDigit(TECShapeLine(sender).Distance,4 )+' Km' ;


end;

// ============================================================================



// ================= ROUTE =====================================================


// add route

//  the calculation is done in a background thread
//  OnRoutePath event is triggered when finished
procedure TForm1.AddLinkClick(Sender: TObject);
begin
 cbPermaLink.Items.Add(map.Url) ;
end;

procedure TForm1.AddRouteClick(Sender: TObject);
begin
 map.GetAsyncRoutePathByAdress(Routestart.Text,RouteEnd.text)
end;


// event OnRoutePath
procedure TForm1.mapRoutePath(sender: TObject; const params: string;
  routePath: TECRoutePath);
var line         : TECShapeLine;
    DrawingRoute : TECAnimationDrawPath;
begin


 if routePath.Distance=0 then
 begin
  ShowMessage('Route not found !');
  exit;
 end;

 infoRoute.text := 'Distance : '+DoubleToStrDigit(routePath.Distance/1000,2)+' km';

                 //  'Time : '+DoubleToStrDigit(routePath.Duration/3600,2)+'h';


// add line on group 'routes'
line := map.addRoute(routePath,'routes');
line.weight  := 4;
//line.opacity := 80;
line.color   := GetRandomColor;
// add border
line.BorderSize  := 2;
line.BorderColor := GetShadowColorBy(line.color,32) ;
// line.Editable := true;


 // see the totality of the road

 line.fitBounds;

 // draw route in 3s
 // DrawingRoute will be automatically deleted
 DrawingRoute := TECAnimationDrawPath.Create(3000);
 DrawingRoute.OnEndAnimation := doOnDrawAllRoute;

 line.Animation := DrawingRoute;

end;


// call by TECAnimationDrawPath  when route is 100% draw
procedure TForm1.doOnDrawAllRoute(sender : TObject);
var line   : TECShapeLine;
    moving : TECAnimationMoveOnPath;
    i      : integer;
    iw     : TECShapeInfoWindow;
begin

 if not assigned(sender) or not(Sender is TECShapeLine) then exit;

 line := sender as TECShapeLine;

// show hotspot text information
 line.ShowText := true;

 // editing mode
 FecNativeLineToRoute.line := line;

 // for select line in editing mode
 line.OnShapeMouseOver := doOnLineMouseOver;

 // change default poi start and finish of route

 if line.shapes.Pois.count>1 then
 begin
   i := line.shapes.markers.add(line.shapes.pois[0].latitude,line.shapes.pois[0].longitude);
   line.shapes.markers[i].filename := 'http://www.helpandweb.com/flag_blue.png';
   line.shapes.markers[i].hint := line.shapes.pois[0].hint;

   i := line.shapes.markers.add(line.shapes.pois[1].latitude,line.shapes.pois[1].longitude);
   line.shapes.markers[i].XAnchor  := 0;
   line.shapes.markers[i].filename := 'http://www.helpandweb.com/checkered_flag.png';

   line.shapes.markers[i].hint := line.shapes.pois[1].hint;

   // hide default start and finish
   line.shapes.pois[0].visible := false;
   line.shapes.pois[1].visible := false;
 end;

 line.OnShapePathChange := doPathChange;


 // add triangle moving on route


 // create triangle
  i := map.shapes.pois.Add(0,0);
  map.shapes.pois[i].POIShape := poiTriangle;
  map.shapes.pois[i].width    := 18;
  map.shapes.pois[i].height   := 24;

  map.shapes.pois[i].color := GetShadowColorBy(line.color,32);
  // to adjust the hint with every movement
  map.shapes.pois[i].OnShapeMove := doOnMoveTriangle;

  // ajusted the relative position and size of label
  FLabelLayer.YAnchor := 10;
  FLabelLayer.Width   := 150;

  // add label to triangle
  FLabelLayer.Add(map.shapes.pois[i]);


 // move on line
 // start km 0
 //speed at 50 + random(5)*10  km/h
 moving := TECAnimationMoveOnPath.create(line,0,50 + random(5)*10);

 //  directing the tip of the triangle in the direction of travel
 moving.heading := true;


 // moving will be automatically deleted
 map.shapes.pois[i].animation := moving;


 // create InfoWindow and keep is index
 // used when the shape reaches the end of road see  doEndAnimationMove
 map.shapes.pois[i].tag := FInfoWindowShapes.InfoWindows.add(-10,-10,'');

 // setup infowindow
 iw := FInfoWindowShapes.InfoWindows[map.shapes.pois[i].tag];

 iw.CloseButton   := false;
 iw.ContentCenter := true;

 iw.color         := claBeige;
 iw.Style         := iwsRectangle;

 // infowindow on top of all shapes
 iw.Zindex        := map.TopGroupZIndex;

 // fired when arrived at end (or at start)
 moving.OnDriveUp := doEndAnimationMove;
 // run animation
 moving.stop := false;

end;

// fired when triangle move
procedure TForm1.doOnMoveTriangle(sender : TObject;const Item : TECShape; var cancel:boolean);
var lat,lng : string;
begin
 if assigned(item) then
 begin

  lat := DoubleToStrDigit(item.Latitude,4);
  Lng := DoubleToStrDigit(item.Longitude,4);

  while length(lat)<7 do  lat := ' '+lat;
  while length(lng)<7 do  lng := ' '+lng;


  item.Hint := '<font face="Courier New" bkcolor=000 color=ffffff height=14>Lat:</font><font height=14 face="Courier New" bkcolor=000 color=ff0000>'+Lat+'</font><br="-5">'+
               '<font face="Courier New" bkcolor=000 color=ffffff>Lng:</font><font face="Courier New" bkcolor=000 color=FF0000>'+Lng+'</font>';
 end;
end;

//  on mouseover, the road passes in edit mode
procedure TForm1.doOnLineMouseOver(sender: TObject; const item: TECShape);
begin

 if item is TECShapeLine then
  FecNativeLineToRoute.line := TECShapeLine(item);

end;

// fired when the triangle reaches the end of road
procedure TForm1.doEndAnimationMove(sender : TObject);
var iw : TECShapeInfoWindow;
begin

  // we got it reverses direction
  TECAnimationMoveOnPath(TECShape(sender).animation).ComeBack := not TECAnimationMoveOnPath(TECShape(sender).animation).ComeBack;
  TECAnimationMoveOnPath(TECShape(sender).animation).Stop := false;


  // show infowindow

  iw := FInfoWindowShapes.InfoWindows[TECShape(sender).Tag];

  iw.SetPosition(TECShape(sender).Latitude,TECShape(sender).Longitude);

  // InfoWindow Content can interpret basic html commands
  iw.Content   := '<img src="http://www.helpandweb.com/icon-damier.png" width=42 height=21> <b>Arrived !</b>'  ;

  iw.Visible := true;


  // The release of the animation is automatically
  iw.Animation := TECAnimationAutoHide.create;

  // auto hide infowindow after 2s
  TECAnimationAutoHide(iw.Animation).MaxTiming := 2000;
end;




// =============================================================================






// ====================== Panoramio ============================================


procedure TForm1.ckPanoramioClick(Sender: TObject);
begin
 map.PanoramioLayer := not ckPanoramio.isChecked;
end;




// Event Click on panoramio photo
procedure TForm1.mapPanoramioClick(sender: TObject; const Item: TECShape;
  const ownerId, ownerName, PhotoId, PhotoDate, PhotoTitle, PhotoUrl,
  copyright: string);
var s:string;
begin

 s := '<img src="'+PanoramioPhotoUrlSize(photourl,pimSmall)+'" ><br><h3>'+PhotoTitle+'</h3>';

 OpenInfoWindow(s,item.Latitude,item.Longitude);


end;


// =============================================================================







// ==================== MARKERS ================================================


// Add default marker
procedure TForm1.DefaultMarkerClick(Sender: TObject);
var i:integer;
begin

  i := map.shapes.markers.add( map.latitude,map.longitude);
 map.shapes.markers[i].Draggable := true;

// Map.shapes.markers[i].Opacity := 50;

 map.shapes.markers[i].Color      := getRandomColor;
 map.shapes.markers[i].HoverColor := GetHighlightColorBy(map.shapes.markers[i].Color,64);

 // 20 flashing ,  TECAnimationShapeColor is is automatically released
 map.shapes.markers[i].animation := TECAnimationShapeColor.create(20);

 map.shapes.markers[i].hint := 'Latitude <tab="100">: <b>'+DoubleToStrDigit( map.shapes.markers[i].latitude,4)+ '</b> <br>'+
                               'Longitude <tab="100">: <b>'+ DoubleToStrDigit( map.shapes.markers[i].longitude,4)+'</b>';

 // trak move for update hint
 map.shapes.markers[i].OnShapeMove := doOnShapeMove;

end;

// fired when default, images and Pois markers move
procedure TForm1.doOnShapeMove(sender: TObject; const item: TECShape;var cancel: boolean);
begin
  if not Assigned(item) then Exit;
  // update hint info position
  item.Hint := 'Latitude <tab="100">: <b>'+DoubleToStrDigit( item.latitude,4)+ '</b> <br>'+'Longitude <tab="100">: <b>'+ DoubleToStrDigit( item.longitude,4)+'</b>';
end;


// add image marker
procedure TForm1.MarkerImageClick(Sender: TObject);
var i:integer;
    amf : TECAnimationMarkerFilename;
begin



 // 14 Maximum cycle, the last defined the final image
 amf := TECAnimationMarkerFilename.create(1+random(13));


 amf.Filenames.add('http://maps.google.com/mapfiles/ms/icons/yellow-dot.png');
 amf.Filenames.add('http://maps.google.com/mapfiles/ms/icons/orange-dot.png');
 amf.Filenames.add('http://maps.google.com/mapfiles/ms/icons/red-dot.png');
 amf.Filenames.add('http://maps.google.com/mapfiles/ms/icons/pink-dot.png');
 amf.Filenames.add('http://maps.google.com/mapfiles/ms/icons/purple-dot.png');
 amf.Filenames.add('http://maps.google.com/mapfiles/ms/icons/green-dot.png');
 amf.Filenames.add('http://maps.google.com/mapfiles/ms/icons/blue-dot.png');
 amf.Filenames.add('http://maps.google.com/mapfiles/ms/icons/ltblue-dot.png');

 // not required
 for i:=0 to  amf.Filenames.count-1 do
  Map.PreLoadGraphic(amf.Filenames[i]);


  i := map.shapes.markers.add( map.latitude,map.longitude);
  map.shapes.markers[i].Draggable := true;

  // amf is is automatically released
 map.shapes.markers[i].animation := amf;

//  Map.shapes.markers[i].Opacity := 50;

 Map.shapes.markers[i].Filename := amf.Filenames[0];

// Map.shapes.markers[i].angle := random(360);

 // sample get streetview image
 // latitude  = 43.2325
 // longitude = 0.0739
 // size = 320x180
 (*
    Map.shapes.markers[i].Filename := 'http://maps.googleapis.com/maps/api/streetview?location=43.2325,0.0739&size=320x180&sensor=false';
    Map.shapes.markers[i].Width := 320;
    Map.shapes.markers[i].Height:= 180;
  *)

  map.shapes.markers[i].hint :='Latitude <tab="100">: <b>'+DoubleToStrDigit( map.shapes.markers[i].latitude,4)+ '</b> <br>'+
                               'Longitude <tab="100">: <b>'+ DoubleToStrDigit( map.shapes.markers[i].longitude,4)+'</b>';
 // track move for update hint
 map.shapes.markers[i].OnShapeMove := doOnShapeMove;
end;


// add POI

procedure TForm1.MarkerPOIClick(Sender: TObject);
var i:integer;
    c:TAlphaColor;
    ShapePOI : TECShapePOI;
    anim : TECAnimationFadePoi;
begin

 map.beginupdate;

 map.group['pois'].ZIndex := 100;

 i := map.group['pois'].pois.add(map.Latitude,map.Longitude);

 ShapePOI := map.group['pois'].pois[i];

 ShapePOI.width := 24;
 ShapePOI.height:= 24;

 ShapePOI.Hint  := 'Poi n'+inttostr(i);

 ShapePOI.Draggable := true;


// map.shapes.pois[i].Opacity := 50;

 c := GetRandomColor;


ShapePOI.Color := c   ;

       case random(7) of
        0 : ShapePOI.POIShape := poiEllipse;
        1 : ShapePOI.POIShape := poiStar;
        2 : ShapePOI.POIShape := poiRect;
        3 : ShapePOI.POIShape := poiTriangle;
        4 : begin
             ShapePOI.POIShape := poiText;

             ShapePOI.OnShapeFont := doFontPOI;
             // fix font size see doFontPOI
             ShapePOI.Tag := 10 + Random(10);
             //
             if ShapePOI.Tag>12 then
             begin
               // with = 0 => 1 line auto calc with
               ShapePOI.Width := 0;

             end else begin
                       // multi line
                       ShapePOI.Width := 50;
                       ShapePOI.Height:= 40;
                       end;

             ShapePOI.description     := 'Multi line '+ShapePOI.Hint;
            // ShapePOI.EnabledHint := false;
            end;
        5 : ShapePOI.POIShape := poiHexagon;
        6 : ShapePOI.POIShape := poiDiamond;
       end;

// ShapePOI.angle := random(360);

if (ShapePOI.POIShape <> poiOwnerDraw)and(ShapePOI.POIShape <> poiText) then
begin
  // trak move for update hint
 ShapePOI.OnShapeMove := doOnShapeMove;

 ShapePOI.hint := 'Latitude <tab="100">: <b>'+DoubleToStrDigit( ShapePOI.latitude,4)+ '</b> <br>'+
                  'Longitude <tab="100">: <b>'+ DoubleToStrDigit( ShapePOI.longitude,4)+'</b>';

  // anim
 if (random(2)=0) then
 begin

   anim := TECAnimationFadePoi.Create;
   anim.MaxSize   := 32;
   anim.StartSize := 8 ;

   anim.StartOpacity := 90;

   ShapePOI.Animation := anim;

  end;
end;


 map.EndUpdate;


end;




// draw number on shape
procedure TForm1.doNumDrawPOI(const canvas:TECCanvas;var r:TRect;item:TECShape) ;
var x,y,w,h : integer;
   s : string;
begin

    // don't draw nomber on animated shape

    if assigned(item.Animation) then
      exit;


    canvas.font.style := [TFontStyle.fsBold];

    s := inttostr(item.Id);


    w := canvas.TextWidth(s) ;
    h:= canvas.TextHeight(s) ;



    x := 1+((r.Left + r.Right) - w) DIV 2   ;
    y := 1+((r.Top + r.Bottom) - h) DIV 2 ;

    canvas.fontcolor := claWhite;

   canvas.TextRect(r,x,y,s);
end;


procedure TForm1.doFontPOI(const canvas:TECCanvas;item:TECshape) ;
begin
  canvas.Font.Size := item.Tag;
end;

// owner draw poi, here transparancy text
procedure TForm1.doOwnerDrawPOI(const canvas:TECCanvas;var Rect:TRect;item:TECshape) ;
begin



  if item.Hover then
     canvas.fontcolor := item.HoverColor
    else
     canvas.fontcolor := item.color;


  canvas.font.Style := [TFontStyle.fsBold];

  if  item.Width = 0 then
   item.Width  := canvas.TextWidth(item.description)+20 ;

  (*
  item.Width  := canvas.TextWidth(item.hint) ;
  item.height := canvas.TextHeight(item.hint) ;
  *)

  canvas.DrawText(item.description,rect);

  //canvas.TextOut(item.x,item.y,item.hint);

end;


// =============================================================================




// =========== InfoWindow ======================================================


procedure TForm1.OpenInfoWindow(const content:string;const Latitude,Longitude:single);
begin

 Editshape(false);


 if FInfoWindowShapes.InfoWindows.count = 0 then
 begin
   FInfoWindowShapes.InfoWindows.add(Latitude,Longitude,content);
   FInfoWindowShapes.InfoWindows[0].zindex := 100;
 end

 else

 begin
   FInfoWindowShapes.InfoWindows[0].content := Content;
   FInfoWindowShapes.InfoWindows[0].SetPosition(Latitude,Longitude);
 end;



 FInfoWindowShapes.InfoWindows[0].closebutton := true;
 FInfoWindowShapes.InfoWindows[0].Visible     := true;


 FInfoWindowShapes.InfoWindows[0].CenterOnMap;

 // window on top
 FInfoWindowShapes.zindex :=  Map.TopGroupZIndex;

end;



// =============================================================================





procedure TForm1.TrafficClick(Sender: TObject);
begin
 map.TrafficLayer := not traffic.isChecked;
end;



procedure TForm1.websiteClick(Sender: TObject);
begin
 //ShellExecute(0, 'OPEN', PChar('http://www.helpandweb.com/ecmap/en/tecnativemap.htm'), '', '', SW_SHOWNORMAL);
end;

end.
