unit UMain3D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ECMaps, StdCtrls, OleCtrls, SHDocVw;

type
  TFDemo3D = class(TForm)
    pnActions: TPanel;
    Panel2: TPanel;
    pnWeb: TPanel;
    WebBrowser: TWebBrowser;
    pnAdresses: TPanel;
    Panel1: TPanel;
    CalculRoute: TButton;
    pnInfos: TPanel;
    pnInfoKmLocation: TPanel;
    InfoKm: TLabel;
    InfoLocation: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    KmMinus: TButton;
    KmPlus: TButton;
    Speed: TPanel;
    lbstart: TLabel;
    cbStart: TComboBox;
    Label1: TLabel;
    cbDestination: TComboBox;
    map: TECMap;
    GroupBox1: TGroupBox;
    rbIE: TRadioButton;
    rbChromium: TRadioButton;
    procedure mapLoad(Sender: TObject);
    procedure mapEarthViewInit(Sender: TObject);
    procedure CalculRouteClick(Sender: TObject);
    
    procedure KmMinusClick(Sender: TObject);
    procedure KmPlusClick(Sender: TObject);
    procedure mapEarthViewFrameEnd(Sender: TObject);
    procedure mapRouteError(sender: TObject; const idRoute: Integer;
      const sError: String);
    procedure cbStartChange(Sender: TObject);
    procedure cbStartKeyPress(Sender: TObject; var Key: Char);

    procedure mapRouteChange(sender: TObject; const idRoute: Integer;
      const NewRoute: Boolean);
    procedure mapGeoLocation(sender: TObject; const dLatitude,
      dLongitude: Double; const sAdresse: string);
    procedure mapJavascriptError(sender: TObject; const sError: string);

    procedure mapChangeMapBounds(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mapEarthViewShow(Sender: TObject);
    procedure mapMapMouseMove(sender: TObject; const dLatitude,
      dLongitude: Double);

  private
    { Dclarations prives }
   
    CamLat,
    CamLng     : double ;


    CamHeading : integer;

    FisMove       : boolean;
    FStepMove     : integer;
    FDistanceMove : double;
    FSpeedMove    : integer;


    FFrequency,
    FTimingLastMove,
    FTimingLocation     : int64;
 

    FComboQueryAdress : TComboBox;

  
    
  public
    { Dclarations publiques }
  end;

var
  FDemo3D: TFDemo3D;

implementation

{$R *.DFM}

uses UECMapUtil,math;


const HTML_BODY_TEMPLATE = '<html><style type="text/css">'+
          'body{ background: #fff;font: 12pt verdana;color: #111;overflow-x:hidden;'+
	               'margin : 0;'+
                 'border-style :none;'+
               '}'+
          'div {margin:0;padding:5px;width:100%;overflow-x:hidden}'+
          '.km {margin:0;color:#4FB2FF;font-size:x-small; text-align:right}'+
          '.odd{background: #eee;color: #000000;}'+
          '</style><body>';


procedure TFDemo3D.KmMinusClick(Sender: TObject);
var KmH:integer;
begin

  if not FIsMove then exit;

  KmH :=  strToInt(speed.caption)-10;

  speed.caption := IntToStr(KmH);;

  // km/h -> m/s
 FSpeedMove    := round( KmH*1000  div 3600);

 //map.EarthView.FlyToSpeed := (Kmh / 90) ;


end;

procedure TFDemo3D.KmPlusClick(Sender: TObject);
var KmH:integer;
begin

  if not FIsMove then exit;

  KmH :=  strToInt(speed.caption)+10;

  if KmH>500 then KmH := 500;

  speed.caption := IntToStr(KmH);;

  // km/h -> m/s
 FSpeedMove    := round( KmH*1000  div 3600);

 //map.EarthView.FlyToSpeed := (Kmh / 90) ;


end;


procedure TFDemo3D.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 action := caFree;
end;

procedure TFDemo3D.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  FisMove := false;
 map.EarthView.visible := false;

end;

procedure TFDemo3D.cbStartChange(Sender: TObject);
begin
  CalculRoute.enabled := (cbStart.text<>'') and (cbDestination.text<>'');
end;




{*
  event OnLoad

  fired when map first load

}
procedure TFDemo3D.mapLoad(Sender: TObject);
begin


 pnActions.enabled      := true;

 map.EarthView.Visible   := true;


end;


procedure TFDemo3D.mapMapMouseMove(sender: TObject; const dLatitude,
  dLongitude: Double);
begin
end;

{*
  event OnEarthViewInit

  fired when plugging 3D ok

}
procedure TFDemo3D.mapEarthViewInit(Sender: TObject);
begin


  caption := caption + ' - Plugin Version: '+map.EarthView.PluginVersion+' - Api Version: '+map.EarthView.ApiVersion;



  map.EarthView.Atmosphere := true;
  map.EarthView.StatusBar  := true;
//  map.EarthView.EnableLayer('LAYER_TERRAIN',true);
  map.EarthView.EnableLayer('LAYER_BUILDINGS',true);
  map.EarthView.NavigationControlVisibility:= ncvHide;//'VISIBILITY_HIDE';

  //map.EarthView.models.LoadKml('http://earth-api-samples.googlecode.com/svn/trunk/demos/drive-simulator/smart.kmz');

  pnActions.enabled := true;

  map.EarthView.altitude := 0;
  map.EarthView.Tilt := 90;
  map.EarthView.Range:= 0;
 map.EarthView.camera(map.latitude,map.longitude);




  //show;
end;



procedure TFDemo3D.mapEarthViewShow(Sender: TObject);
begin


end;

{*
   event OnGeoLocation

   fired by map.GeoLocation(...)

   @param sender instance of component TECMap
   @param dLatitude  latitude of first response
   @param dLongitude longitude of first response
   @param sAdresse   adresse of first response

}
procedure TFDemo3D.mapGeoLocation(sender: TObject; const dLatitude,
  dLongitude: Double; const sAdresse: string);
begin


 if FisMove then
 begin
    infoLocation.Caption := sAdresse;
 end else

 if assigned(FComboQueryAdress) then
 begin
  FComboQueryAdress.Items.text := map.Adresses.Adresses;
  FComboQueryAdress.ItemIndex  := 0;//index;
  FComboQueryAdress            := nil;
 end;
end;

procedure TFDemo3D.mapJavascriptError(sender: TObject; const sError: string);
begin

end;

{*
   press RETURN key on combobox start and destination for Geolocalize adress

   fired event OnGeoLocation
}
procedure TFDemo3D.cbStartKeyPress(Sender: TObject; var Key: Char);
var lat,lng : double;
begin

 if Key=#13 then
 begin
  FComboQueryAdress := Sender As TComboBox;
  if assigned(FComboQueryAdress)
   then  map.GeoLocation(FComboQueryAdress.text);
 end;

end;



procedure TFDemo3D.mapChangeMapBounds(Sender: TObject);
begin
end;

{*
   Add new route
}
procedure TFDemo3D.CalculRouteClick(Sender: TObject);
var lat1,lng1,lat2,lng2:double;
begin





 if map.EarthView.models.count=0 then


 map.EarthView.models.LoadKml('http://earth-api-samples.googlecode.com/svn/trunk/demos/drive-simulator/smart.kmz');


 InfoKm.caption       := '';
 InfoLocation.caption := '';
 speed.caption        := '';


 FIsMove := false;

 map.Routes.clear;

 if not ((trim(cbStart.text)<>'')and(trim(cbDestination.text)<>'')) then
 begin
  CalculRoute.enabled := true;
  exit;
 end;


 // GetLatLngFromAdress fired mapAdress
 // mapAdress fill the combo with adresses
 FComboQueryAdress := cbStart;

 if not map.GetLatLngFromAdress(cbStart.text,lat1,lng1) then exit;


 map.EarthView.camera(lat1,lng1);

 FComboQueryAdress := cbDestination;

 if not map.GetLatLngFromAdress(cbDestination.text,lat2,lng2) then exit;



  // no other route when calcul
  CalculRoute.enabled := false;

 FComboQueryAdress := nil;

  // add route on map

  map.Routes.Add('route',lat1,lng1,lat2,lng2,false,nil);
 
end;



{*
    event OnRouteAdd
}
procedure TFDemo3D.mapRouteChange(sender: TObject; const idRoute: Integer;Const NewRoute:boolean);
var i,j:integer;
    html,s:string;
    odd:boolean;
begin
 CalculRoute.Enabled := true;

 if not assigned(map.routes[idRoute]) then exit;


 cbStart.Text       := map.routes[idRoute].StartAdress;
 cbDestination.Text := map.routes[idRoute].EndAdress;


 j := map.Routes[idroute].Path.count-1;

 // instructions step by step
 html := HTML_BODY_TEMPLATE;


 odd := false;

 for i:=0 to j do
 begin
  // all steps have no instructions
  s := map.Routes[idroute].Path[i].instructions;
  if s='' then continue;

  html := html+'<div id="step'+inttostr(i)+'"';

  if odd then html:=html+' class="odd"';
  odd := not odd;

   html:=html+'>'+s+'<div class="km">'+format('%8.2f km',[map.routes[idRoute].Path[i].distance/1000])+'</div>'+'</div>';
 end;

 html := html + '</body></html>';

 WebBrowserLoadHtml(WebBrowser,html);



 // teleportation to start
 map.EarthView.FlyToSpeed := 6.0;
 CamLat := map.routes[idRoute].Path[0].Latitude;
 CamLng := map.routes[idRoute].Path[0].Longitude;
 map.EarthView.altitude := 0;
 map.EarthView.camera(CamLat,CamLng);



 // smooth move
  map.EarthView.FlyToSpeed := 2.0;//(100 / 100);

 //
 FTimingLocation := getTickCount;
 
 //
 speed.caption := '80';
 FDistanceMove := 0;

 // km/h -> m/s
 FSpeedMove    := round( 80*1000  div 3600);
 FStepMove     := 0;

 FTimingLastMove := FTimingLocation;


 FisMove := true;

end;




{*
  event OnRouteError

}
procedure TFDemo3D.mapRouteError(sender: TObject; const idRoute: Integer;
  const sError: String);
begin
  if CalculRoute.enabled then exit;

  FIsMove := false;

  WebBrowserLoadHtml(WebBrowser,HTML_BODY_TEMPLATE+'<h1>'+sError+'</h1></body></html>');
  map.routes.clear;
  CalculRoute.enabled := true;
end;







{*
   event EArthViewFrameEnd

   fired when EarthView ok to draw

}

procedure TFDemo3D.mapEarthViewFrameEnd(Sender: TObject);
var iStep,meter  : integer;
    Timing : int64;
    bEnd   : boolean;
begin


 if FIsMove then
 begin

  timing := getTickCount;





  FdistanceMove   := FdistanceMove + ((((timing-FtimingLastMove) )/ 1000)*(FSpeedMove));
  infoKm.caption  := format('%.3f',[(FdistanceMove / 1000)])+' Km ' ;





   FtimingLastMove := timing;




  FisMove := map.routes[0].getLatLngFromMeter(true,round(FdistanceMove),CamLat,CamLng,iStep,Camheading,bEnd);


  if assigned(map.EarthView.Models[0]) then
  begin
   map.EarthView.Models[0].Heading := CamHeading;

   map.EarthView.Models[0].setLatLngAlt(CamLat,CamLng,0);
  end;

   map.EarthView.Heading := CamHeading;
  
  if FStepMove<>iStep then
  begin

    FStepMove := iStep;
     
    WebBrowserExecJS(WebBrowser,'window.step = "step'+inttostr(istep)+'";'+

                                 'var e=document.getElementById(window.step);'+
                                 'if (e!=null){'+
                                 'e.scrollIntoView(true);' +
                                 'var o = document.getElementById(window.old);'+
                                 'if (o!=null) {o.style.cssText="color:#0";}'+
                                 'e.style.cssText="color:'+ColorToHTML(clGreen)+'";'+
                                 'window.old = window.step;}'
                                );
  end;





  If bEnd then
  begin
   FIsMove := false;
   WebBrowserLoadHtml(WebBrowser,HTML_BODY_TEMPLATE+'<h1>Arrived at '+map.routes[0].EndAdress+'</h1></body></html>');

  end;




  map.routes[0].getLatLngFromMeter(true,round(FdistanceMove)+10,CamLat,CamLng,iStep,Camheading,bEnd) ;

  map.EarthView.Tilt := 90;
  map.EarthView.Range:= 0;

  map.EarthView.AltitudeMode := amAbsolute;
  map.EarthView.Altitude     := map.EarthView.getGroundAltitude(camLat,camLng) + 5;


  map.EarthView.camera(CamLat,CamLng);


  //map.EarthView.Range := 50;

  // every 10 secondes get adress
 if getTickcount-FTimingLocation>10000 then
  begin
    FTimingLocation := getTickCount;
    FComboQueryAdress := nil;
    map.GeoLocationFromLatLng(camLat,camLng);
 //   infoLocation.Caption := map.GetAdressFromLatLng(camLat,camLng);
  end;


 end;



end;








end.
