unit UMainAdressEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ECMaps, UECMapAdressEdit,UECMapUtil, ExtCtrls, Grids,
  UECStaticMap;

type
  TFormAdressEdit = class(TForm)
    pn_adressedit: TPanel;
    pn_infoAdressEdit: TPanel;
    AdressEdit: TECAdressEdit;
    map: TECMap;
    Label1: TLabel;
    Matrix: TStringGrid;
    pn_static_view: TPanel;
    ECStaticMap: TECStaticMap;
    staticapi: TComboBox;
    spai: TLabel;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MatrixDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure AdressEditSelect(Sender: TObject);
    procedure AdressEditExit(Sender: TObject);
    procedure mapLoad(Sender: TObject);
    procedure AdressEditAdress(sender: TObject; const Latitude,
      Longitude: Double);
  private
    { Dclarations prives }
    procedure UpdateMatrix;

  public
    { Dclarations publiques }
  end;

var
  FormAdressEdit: TFormAdressEdit;

implementation

{$R *.dfm}



procedure TFormAdressEdit.AdressEditAdress(sender: TObject; const Latitude,
  Longitude: Double);
begin
 map.setCenter(latitude,longitude);
 map.markers[0].Icon := AdressEdit.Nominatim.Icon;
 map.markers[0].SetPosition(Latitude,Longitude);

 map.InfoWindows[0].content := AdressEdit.Nominatim.Display_name;
 map.InfoWindows[0].open := true;
end;

procedure TFormAdressEdit.AdressEditExit(Sender: TObject);
var i:integer;
begin
  for i:=0 to 9 do
   Matrix.Cells[1,0] := '';

end;

procedure TFormAdressEdit.AdressEditSelect(Sender: TObject);
begin
 Matrix.Cells[1,0] := AdressEdit.nominatim.Display_name;
 Matrix.Cells[1,1] := DoubleToStr(AdressEdit.nominatim.Latitude);
 Matrix.Cells[1,2] := DoubleToStr(AdressEdit.nominatim.Longitude);
 Matrix.Cells[1,3] := AdressEdit.nominatim.BoundingBox;
 Matrix.Cells[1,4] := AdressEdit.nominatim.Place_type;
 Matrix.Cells[1,5] := AdressEdit.nominatim.Place_rank;
 Matrix.Cells[1,6] := AdressEdit.nominatim.Place_id;
 Matrix.Cells[1,7] := AdressEdit.nominatim.Osm_type;
 Matrix.Cells[1,8] := AdressEdit.nominatim.Osm_id;
 Matrix.Cells[1,9] := AdressEdit.nominatim.Icon;

 case staticapi.ItemIndex of
  2 : ECStaticMap.Api := saOpenMapQuest;
  1 : ECStaticMap.Api := saStreetView;
  else ECStaticMap.Api := saGoogle;
 end;

 ECStaticMap.Latitude  := AdressEdit.nominatim.Latitude;
 ECStaticMap.Longitude := AdressEdit.nominatim.Longitude;
 ECStaticMap.Zoom      := 14;
 ECStaticMap.LoadMap;

end;

procedure TFormAdressEdit.FormCreate(Sender: TObject);
begin
 Matrix.Cells[0,0] := 'Display_name';
 Matrix.Cells[0,1] := 'Latitude';
 Matrix.Cells[0,2] := 'Longitude';
 Matrix.Cells[0,3] := 'BoundingBox';
 Matrix.Cells[0,4] := 'Place_Type';
 Matrix.Cells[0,5] := 'Place_Rank';
 Matrix.Cells[0,6] := 'Place_Id';
 Matrix.Cells[0,7] := 'Osm_Type';
 Matrix.Cells[0,8] := 'Osm_Id';
 Matrix.Cells[0,9] := 'Icon';

 staticapi.ItemIndex := 0;

end;

procedure TFormAdressEdit.FormResize(Sender: TObject);
begin
 Matrix.ColWidths[0] := 120;
 Matrix.ColWidths[1] := Self.clientwidth - Matrix.ColWidths[0] - pn_static_view.width;
end;

procedure TFormAdressEdit.mapLoad(Sender: TObject);
begin


 // link infowindow width marker
 map.InfoWindows[map.InfoWindows.Add('')].Anchor := map.Markers.Add(map.Latitude,map.longitude) ;
end;

procedure TFormAdressEdit.MatrixDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
With Sender As TStringGrid Do With Canvas Do
  Begin



    If (gdFixed in State) and ((ACol>0)or(ARow>0)) Then
      Brush.Color := clBtnFace
    Else Brush.Color := clWhite;


    FillRect(Rect);


    Pen.Color := cl3DLight;

    Pen.width := 1;

    Moveto(rect.left,rect.bottom-1);
    Lineto(rect.right-1,rect.bottom-1);
    LineTo(rect.right-1,rect.top-1);


    if (ACol=0)or(ARow=0) then
     Canvas.Font.Style := [fsBold]
    else
     Canvas.font.Style := [];

    SetTextColor(Canvas.Handle,clBlack);

    if (ACol=0)or(ARow=0) then

     DrawText(Canvas.Handle, PChar(Cells[aCol,aRow]), -1, Rect ,
              DT_CENTER or DT_VCENTER or DT_NOPREFIX or DT_SINGLELINE )

    else
     begin
      rect.top := rect.top + 4;
      DrawText(Canvas.Handle, PChar(Cells[aCol,aRow]), -1, rect ,
              DT_CENTER or DT_NOPREFIX or DT_WORDBREAK ) ;
     end;




  End;
end;

procedure TFormAdressEdit.UpdateMatrix;
var origins,destinations:string;
    i:integer;
begin

 //


end;

end.
