unit UDemoLayer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ECMaps, ExtCtrls, StdCtrls, ComCtrls, Spin,UECMapUtil;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    map: TECMap;
    btGo: TButton;
    adresse: TComboBox;
    PageControl1: TPageControl;
    TabPano: TTabSheet;
    TabKml: TTabSheet;
    TabFusionTables: TTabSheet;
    ckRemoveInfoWindowFusionTables: TCheckBox;
    Tabbike: TTabSheet;
    TabTraffic: TTabSheet;
    Panel2: TPanel;
    ckClickPano: TCheckBox;
    ckInfoWindows: TCheckBox;
    Label8: TLabel;
    TagPano: TEdit;
    Label69: TLabel;
    UserIdPano: TEdit;
    Panel3: TPanel;
    Label1: TLabel;
    InfoPano: TMemo;
    pnPano: TPanel;
    radius: TSpinEdit;
    Label3: TLabel;
    btSearch: TButton;
    Panel4: TPanel;
    btShow: TButton;
    ckAllImage: TCheckBox;
    memopano: TMemo;
    procedure mapMapClick(sender: TObject; const dLatitude,
      dLongitude: Double);
    procedure mapLoad(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure btGoClick(Sender: TObject);
    procedure AdresseKeyPress(Sender: TObject; var Key: Char);
    procedure mapMapMove(sender: TObject; const dLatitude,
      dLongitude: Double);
    procedure mapAdress(sender: TObject; const sAdresses: String;
      var Index: Integer);
    procedure ckClickPanoClick(Sender: TObject);
    procedure ckInfoWindowsClick(Sender: TObject);
    procedure TagPanoKeyPress(Sender: TObject; var Key: Char);
    procedure UserIdPanoKeyPress(Sender: TObject; var Key: Char);
    procedure mapPanoramioLayerClick(sender: TObject; const Author,
      PhotoId, title, Url, UserId, Html: String; const dLatitude,
      dLongitude: Double);
    procedure mapKmlLayerClick(sender: TObject; const idKmlLayer: Integer;
      const htmlDescription, htmlInfoWindow: String; dLatitude,
      dLongitude: Double);
    procedure PageControl1Change(Sender: TObject);
    procedure ckRemoveInfoWindowFusionTablesClick(Sender: TObject);
    procedure mapFusionTablesLayerClick(sender: TObject;
      const idKmlLayer: Integer; const htmlInfoWindow: String; dLatitude,
      dLongitude: Double);
    procedure btSearchClick(Sender: TObject);
    procedure mapPanoramioSearch(sender: TObject; const First, Last: Integer);
    procedure btShowClick(Sender: TObject);
    procedure mapLink(sender: TObject; const Url: string);
  private
    { Dclarations prives }
    idAreaPanoramio, idInfoPanoramio:integer;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const SHOW_BY_ECMAP = '<h1>Show by ECMap.InfoWindow</h1>';

procedure TForm1.Panel1Resize(Sender: TObject);
begin
 btGo.Left := Panel1.Width - btGo.Width - 7;
 Adresse.width := btGo.left - 14;
end;


{*

 event OnLoad

 fired when map loaded

}
procedure TForm1.mapLink(sender: TObject; const Url: string);
begin
 infoPano.Lines.Add(url);
end;

procedure TForm1.mapLoad(Sender: TObject);
begin
 // create infowindow empty
 map.InfoWindows.Add('');
 // check etat
 ckClickPano.checked   := map.PanoramioView.Clickable;
 ckInfoWindows.Checked := map.PanoramioView.SuppressInfoWindows;
 tagPano.text          := map.PanoramioView.Tag;
 userIdPano.text       := map.PanoramioView.UserId;

 PageControl1.ActivePage   := tabPano;
 map.PanoramioView.visible := true;

 idAreaPanoramio := -1;
 idInfoPanoramio := -1;
end;

{*
  click on the map
}
procedure TForm1.mapMapClick(sender: TObject; const dLatitude,
  dLongitude: Double);
begin
 // set adress in infowindow.content
 map.InfoWindows[0].content := map.GetAdressFromLatLng(dLatitude,dLongitude);
 // set infowindow position
 map.InfoWindows[0].setPosition(dLatitude,dLongitude);
 // open infowindow
 map.InfoWindows[0].open := true;
end;





procedure TForm1.btGoClick(Sender: TObject);
begin
 map.adress := Adresse.Text;
end;

procedure TForm1.btSearchClick(Sender: TObject);
begin

 btSearch.enabled := false;

 memoPano.lines.clear;


 map.PanoramioView.SearchAt(map.latitude,map.longitude,radius.value / 1000);
end;

procedure TForm1.btShowClick(Sender: TObject);
var i:integer;
begin
 if idInfoPanoramio = -1 then

  idInfoPanoramio := map.infowindows.add('');


  i := random(map.PanoramioView.count-1);



  map.infoWindows[idInfoPanoramio].open := false;

  map.infoWindows[idInfoPanoramio].content :='<h3>'+map.PanoramioView.photo_title[i]+'</h3>'
                                             +map.PanoramioView.HtmlPhoto(i,pimSmall)

                                              +'<h4>Author: '+map.PanoramioView.owner_name[i]+'</h4>'
                                              +map.PanoramioView.HtmlCopyright(i);



  map.infoWindows[idInfoPanoramio].setPosition(map.PanoramioView.photo_lat[i],map.PanoramioView.photo_lng[i]);

  map.infoWindows[idInfoPanoramio].open := true;

end;

procedure TForm1.AdresseKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then
  map.adress := adresse.text;
end;

{*
  event OnMapMove

}
procedure TForm1.mapMapMove(sender: TObject; const dLatitude,
  dLongitude: Double);
begin
 Adresse.text := map.adress;
end;

{*
  event OnAdress

  @param sAdresses all adress find by geolocalisation
         format :  adr_0#13#10adr_1#13#10...

  @param Index selected adress by defaut 0 (first choice)

  here this event is fired by map.adress := xxx

  also fired by map.GetAdressFromLatLng(latitude,longitude)
  by defaut GetAdressFromLatLng return adr_0, but you
  can modified Index value in OnAdress
}
procedure TForm1.mapAdress(sender: TObject; const sAdresses: String;
  var Index: Integer);
begin
 adresse.items.text := sAdresses;
 adresse.itemindex  := index;
end;


procedure TForm1.ckClickPanoClick(Sender: TObject);
begin
 map.PanoramioView.Clickable := ckClickPano.checked;
end;

procedure TForm1.ckInfoWindowsClick(Sender: TObject);
begin
  map.PanoramioView.SuppressInfoWindows := ckInfoWindows.checked;
end;

procedure TForm1.TagPanoKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then
  map.PanoramioView.Tag := TagPano.text;
end;

procedure TForm1.UserIdPanoKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then
  map.PanoramioView.UserId := UserIdPano.text;
end;


{*
  event PanoramioLayerClick

  fired when click on image panoramio if map.PanoramioView.clickable = true
}
procedure TForm1.mapPanoramioLayerClick(sender: TObject; const Author,
  PhotoId, title, Url, UserId, Html: String; const dLatitude,
  dLongitude: Double);
begin

 InfoPano.Lines.Clear;

 InfoPano.Lines.Add('Author : '+Author);
 InfoPano.Lines.Add('title  : '+title);
 InfoPano.Lines.Add('Url    : '+Url);
 InfoPano.Lines.Add('PhotoId: '+PhotoId);
 InfoPano.Lines.Add('UserId : '+UserId);


 if map.PanoramioView.SuppressInfoWindows then
 begin
  // set adress in infowindow.content
  map.InfoWindows[0].content := SHOW_BY_ECMAP+html;
  // set infowindow position
  map.InfoWindows[0].setPosition(dLatitude,dLongitude);
  // open infowindow
  map.InfoWindows[0].open := true;
 end;
 
end;

procedure TForm1.mapPanoramioSearch(sender: TObject; const First,
  Last: Integer);
var i:integer;
begin


 if idAreaPanoramio=-1 then

   idAreaPanoramio := map.Polygones.add;

 map.Polygones[idAreaPanoramio].Path.clear;

 map.Polygones[idAreaPanoramio].Color := clBlue;
 map.Polygones[idAreaPanoramio].FillColor := clBlue;
 map.Polygones[idAreaPanoramio].Add(map.PanoramioView.LatSW,map.PanoramioView.lngSW);
 map.Polygones[idAreaPanoramio].Add(map.PanoramioView.LatSW,map.PanoramioView.lngNE);
 map.Polygones[idAreaPanoramio].Add(map.PanoramioView.LatNE,map.PanoramioView.lngNE);
 map.Polygones[idAreaPanoramio].Add(map.PanoramioView.LatNE,map.PanoramioView.lngSW);
 map.Polygones[idAreaPanoramio].Add(map.PanoramioView.LatSW,map.PanoramioView.lngSW);
 map.Polygones[idAreaPanoramio].Clickable := false;





 memoPano.lines.beginupdate;


 for i := First to Last-1 do
 begin
   memoPano.lines.add(map.PanoramioView.photo_title[i]);
 end;


 if map.PanoramioView.HasMore then
 begin
   memoPano.Lines.add('Has More : true');

   if ckallImage.checked then
     map.PanoramioView.NextSearch

   else

   btSearch.enabled := true;
 end
 else
  begin
   memoPano.Lines.add('Has More : false') ;
   btSearch.enabled := true;
  end;
 memoPano.lines.endupdate;
end;

procedure TForm1.mapKmlLayerClick(sender: TObject;
  const idKmlLayer: Integer; const htmlDescription, htmlInfoWindow: String;
  dLatitude, dLongitude: Double);

var content:string;

begin



  if htmlDescription<>'' then
   Content := htmlDescription
  else
  if htmlInfoWindow<>'' then
   Content := htmlInfoWindow;

  if content = '' then
   content := map.GetAdressFromLatLng(dLatitude,dLongitude);

 // set adress in infowindow.content
  map.InfoWindows[0].content := SHOW_BY_ECMAP+content;
  // set infowindow position
  map.InfoWindows[0].setPosition(dLatitude,dLongitude);
  // open infowindow
  map.InfoWindows[0].open := true;


end;


procedure TForm1.PageControl1Change(Sender: TObject);
var FusionStyle:string;
begin

 map.PanoramioView.Visible := PageControl1.ActivePage = tabPano;

 map.BicyclingLayer :=  PageControl1.ActivePage = tabBike;

 map.TrafficLayer   := PageControl1.ActivePage = tabTraffic;

 if assigned(map.FusionTablesLayers[0]) then
     map.FusionTablesLayers[0].visible := false;

 if assigned(map.KmlLayers[0]) then
     map.KmlLayers[0].visible := false;



 if PageControl1.ActivePage = tabBike then
 begin
  map.SetCenter(42.3726399, -71.1096528);
  map.zoom := 14;
 end

 else

 if PageControl1.ActivePage = tabTraffic then
 begin
  map.SetCenter(34.04924594193164, -118.24104309082031);
  map.Zoom := 13;
 end

 else

 if PageControl1.ActivePage = tabKml then
 begin

             if map.KmlLayers.Count=0 then
              map.KmlLayers.add('http://sketchup.google.com/3dwarehouse/placemarksanon?clid=f09e176eabd6b58b7a1ca70f93668ed2&rtyp=kml');

             if assigned(map.KmlLayers[0]) then
             begin
              map.KmlLayers[0].visible := true;
              map.KmlLayers[0].show;
              map.Adress := 'brest';
              map.Zoom   := 8;

             end;

 end else




  if PageControl1.ActivePage = TabFusionTables then
   begin
                      if map.FusionTablesLayers.Count = 0 then
                      begin
                       // see http://code.google.com/intl/fr/apis/maps/documentation/javascript/examples/layer-fusiontables-styling.html
                       fusionStyle := '{'+
                                        'polygonOptions: {'+
                                          'fillColor: "#00FF00",'+
                                          'fillOpacity: 0.3'+
                                        '}'+
                                      '},'+
                                      '{'+
                                         'where: "birds > 300",'+
                                           'polygonOptions: {'+
                                            'fillColor: "#0000FF"'+
                                           '}'+
                                      '},'+
                                      '{'+
                                        'where: "population > 5",'+
                                          'polygonOptions: {'+
                                            'fillOpacity: 1.0'+
                                          '}'+
                                        '}';

       map.FusionTablesLayers.Add('geometry','815230',fusionStyle,'');
       map.FusionTablesLayers[0].visible := true;
     end;

     map.Adress := 'australia';
     map.Zoom   := 4;

  end;








end;

procedure TForm1.ckRemoveInfoWindowFusionTablesClick(Sender: TObject);
begin
 if not assigned(map.FusionTablesLayers[0]) then exit;

 map.FusionTablesLayers[0].SuppressInfoWindow := ckRemoveInfoWindowFusionTables.checked;
 map.FusionTablesLayers[0].update;
 
end;

procedure TForm1.mapFusionTablesLayerClick(sender: TObject;
  const idKmlLayer: Integer; const htmlInfoWindow: String; dLatitude,
  dLongitude: Double);
begin
 if map.FusionTablesLayers[idKmlLayer].SuppressInfoWindow then
 begin
  // set adress in infowindow.content
  map.InfoWindows[0].content := SHOW_BY_ECMAP+htmlInfoWindow;
  // set infowindow position
  map.InfoWindows[0].setPosition(dLatitude,dLongitude);
  // open infowindow
  map.InfoWindows[0].open := true;
 end;
end;




end.
