unit UDemoLocalise;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ECMaps,UECMapUtil, ExtCtrls, StdCtrls, Grids;

type
  TFDemoLocalise = class(TForm)
     Panel1: TPanel;
    Panel2: TPanel;
    lbCarte: TLabel;
    cbApi: TComboBox;
    Label1: TLabel;
    cartes: TComboBox;
    Panel3: TPanel;
    Label2: TLabel;
    adresse: TComboBox;
    btGo: TButton;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    radius: TEdit;
    Label4: TLabel;
    btFindPlaces: TButton;
    ckStore: TRadioButton;
    ckRestaurant: TRadioButton;
    ckdoctor: TRadioButton;
    Panel4: TPanel;
    Panel5: TPanel;
    place: TComboBox;
    results: TStringGrid;
    pnDetail: TPanel;
    Panel6: TPanel;
    btDetails: TButton;
    Details: TStringGrid;
    btClear: TButton;
    map: TECMap;
    Label5: TLabel;
    Display: TComboBox;
    osm: TCheckBox;
    

    procedure mapMapClick(sender: TObject; const dLatitude,
      dLongitude: Double);
    procedure mapLoad(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure btGoClick(Sender: TObject);
    procedure AdresseKeyPress(Sender: TObject; var Key: Char);
    
    procedure cbApiChange(Sender: TObject);
    procedure cartesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mapMarkerMove(sender: TObject; const Index: Integer;
      var dLatitude, dLongitude: Double);
    procedure radiusKeyPress(Sender: TObject; var Key: Char);
    procedure btFindPlacesClick(Sender: TObject);
    procedure mapPlacesSearch(Sender: TObject);
    procedure btClearClick(Sender: TObject);
    procedure Panel4Resize(Sender: TObject);
    procedure placeClick(Sender: TObject);
    procedure mapMarkerClick(sender: TObject; const Index: Integer;
      const dLatitude, dLongitude: Double);
    procedure radiusChange(Sender: TObject);
    procedure mapPlacesDetail(Sender: TObject);
    procedure btDetailsClick(Sender: TObject);
    procedure resultsDrawCell(Sender: TObject; aCol, aRow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure mapBeforeChangeMapApi(Sender: TObject);
    procedure mapAfterChangeMapApi(Sender: TObject);
    procedure mapGeoLocation(sender: TObject; const dLatitude,
      dLongitude: Double; const sAdresse: string);
    procedure mapAdress(sender: TObject; const sAdresses: string;
      var Index: Integer);
    procedure DisplayClick(Sender: TObject);
    procedure mapAfterReload(Sender: TObject);
    procedure osmClick(Sender: TObject);
  private
    { Dclarations prives }
   FStartPlace : integer;

   procedure doShowPlaces(const idPlace:integer);
   procedure doClearPlaces;
   procedure doCloseInfoWindows;
   procedure doClearGrids;
  public
    { Dclarations publiques }
  end;

var
  FDemoLocalise: TFDemoLocalise;

implementation

{$R *.DFM}


procedure TFDemoLocalise.Panel1Resize(Sender: TObject);
begin
 btGo.Left := Panel1.Width - btGo.Width - 7;
 Adresse.width := btGo.left - 14 - Adresse.left;
end;


{*

 event OnLoad

 fired when map loaded

}
procedure TFDemoLocalise.mapLoad(Sender: TObject);
var id_marker,id_info:integer;
begin

 if map.Markers.Count=0 then
   id_marker := map.AddMarker(map.Latitude,map.longitude)
 else
  id_marker  := 0;


 map.Markers[id_marker].icon := 'http://maps.google.com/mapfiles/ms/micons/red-pushpin.png';
 map.Markers[id_marker].Draggable := true;


 // create infowindow
 id_info := map.InfoWindows.Add('');
 // link infowindow width marker
 map.InfoWindows[id_info].Anchor := id_marker;
 //
 case map.MapAPI of
   apiGoogle: cbapi.ItemIndex := 0 ;
   apiCloudMade: cbApi.ItemIndex := 1 ;
 end;

 Cartes.Items.Text := map.MapTypes.Text;
 Cartes.ItemIndex := 0;
 pnDetail.visible  := map.MapAPI = apiGoogle;

 case Map.DisplayBrowser of
   dbIE       : Display.ItemIndex := 0;
   dbChromium : Display.ItemIndex := 1;

 end;



end;

{*
  click on the map
}
procedure TFDemoLocalise.mapMapClick(sender: TObject; const dLatitude,
  dLongitude: Double);
begin
 map.Markers[0].setPosition(dLatitude,dLongitude);
 // set adress in infowindow.content
 // GetAdressFromLatLng triggered OnGeoLocation
 map.InfoWindows[0].content := map.GetAdressFromLatLng(dLatitude,dLongitude);

end;





procedure TFDemoLocalise.btGoClick(Sender: TObject);
var i:integer;
begin

  i := Adresse.ItemIndex;

 if (i>-1)and(i<=map.Adresses.count) then
    map.SetCenter(map.Adresses.Latitude[i],map.Adresses.Longitude[i])
 else
    map.adress := Adresse.Text;

end;

procedure TFDemoLocalise.cartesClick(Sender: TObject);
begin
 map.MapTypeId := StrToMt(Cartes.Text);
end;

procedure TFDemoLocalise.cbApiChange(Sender: TObject);
begin
 case cbApi.itemindex of
   0    :  map.MapApi := apiGoogle;
   1    :  map.MapApi := apiCloudMade;
   2    :  map.MapApi := apiOpenMapQuest;
   3    : map.MapAPI  := apiLeaflet;
 end;
end;

procedure TFDemoLocalise.DisplayClick(Sender: TObject);
begin
 case Display.ItemIndex of
  0 : Map.DisplayBrowser :=  dbIE ;
  else
      Map.DisplayBrowser := dbChromium;
 end;

end;

procedure TFDemoLocalise.FormCreate(Sender: TObject);
begin
 Panel1Resize(nil);

 Results.Cells[0,0] := 'Key';
 Results.Cells[1,0] := 'Value';

 Details.Cells[0,0] := 'Key';
 Details.Cells[1,0] := 'Value';

 Radius.text        := '1000';
end;

procedure TFDemoLocalise.AdresseKeyPress(Sender: TObject; var Key: Char);
var lat,lng:double;
begin
 if key=#13 then
   map.GeoLocation(Adresse.text);

end;


{*
   event OnGeoLocation

   fired by map.GeoLocation(...)

   @param sender instance of component TECMap
   @param dLatitude  latitude of first response
   @param dLongitude longitude of first response
   @param sAdresse   adresse of first response

}
procedure TFDemoLocalise.mapGeoLocation(sender: TObject; const dLatitude,
  dLongitude: Double; const sAdresse: string);
begin
 //map.SetCenter(dlatitude,dlongitude);

 Adresse.Items.text := map.Adresses.Adresses;
 Adresse.ItemIndex  := 0;

 map.OnMarkerMove := nil;
 map.Markers[0].setPosition(dLatitude,dLongitude);
 map.OnMarkerMove := mapMarkerMove;



  map.InfoWindows[0].content := sAdresse;
  // set infowindow position
  map.InfoWindows[0].setPosition(dLatitude,dLongitude);
  // open infowindow
  map.InfoWindows[0].open := true;



end;


{*
  event OnMarkerMove

}
procedure TFDemoLocalise.mapMarkerMove(sender: TObject; const Index: Integer;
  var dLatitude, dLongitude: Double);
begin

 // just the marker movable, not places
 if index>0 then exit;

 map.GeoLocationFromLatLng(dLatitude,dLongitude);
(*  // set adress in infowindow.content
 map.InfoWindows[0].content := map.markers[0].adress;//map.GetAdressFromLatLng(dLatitude,dLongitude);
 // set infowindow position
 map.InfoWindows[0].setPosition(dLatitude,dLongitude);
 // open infowindow
 map.InfoWindows[0].open := true;*)
end;



procedure TFDemoLocalise.radiusKeyPress(Sender: TObject; var Key: Char);
begin
 if (not (key in ['0'..'9'])) and (Key<>#8) then
  key := #0;
end;


procedure TFDemoLocalise.doCloseInfoWindows;
var i:integer;
begin
 for i:=0 to map.InfoWindows.count-1 do
  map.InfoWindows[i].open := false;
end;

procedure TFDemoLocalise.btFindPlacesClick(Sender: TObject);
var Tags:string;
    isOSM : boolean;
begin

 btFindPlaces.enabled := false;

 map.Places.Latitude := map.latitude;
 map.Places.Longitude:= map.Longitude;

 //map.Places.MaxResult := StrTOInt(MaxResult.text);

 if map.MapAPI=apiGoogle then
   isOSM := osm.checked
 else
 begin
   isOSM := true;
 end;


 if not IsOSM then


  begin
               if ckStore.checked  then
                Tags := 'store'
               else
               if ckRestaurant.checked then
                Tags := 'restaurant'
               else
               if ckDoctor.checked then
                Tags := 'doctor';
              end

  else begin

        if ckStore.checked       then
         Tags := 'node[shop=*]'
        else
        if ckRestaurant.checked then
            Tags := 'node[amenity=restaurant]'
        else
        if ckDoctor.checked     then
            Tags := 'node[amenity=doctors]';
       end;



 map.Places.Radius := StrToInt(Radius.text);

 map.Places.Search(Tags);
end;

procedure TFDemoLocalise.mapPlacesSearch(Sender: TObject);
var i,max:integer;
    iMarker : integer;
    icon,types,names: string;

begin

  Place.items.clear;

  doCloseInfoWindows;

  btFindPlaces.enabled := (radius.text<>'') and not map.Places.searching;

  if map.Places.Status<>'OK' then exit;


  FStartPlace := map.Markers.count-1;

  max := map.Places.Results.count-1;


  place.Items.BeginUpdate;



  for i:=0 to max do
  begin


    types:= map.Places.Results[i].result['types'];
    names:= map.Places.Results[i].result['name'];

    if names='' then names:='unknown';



      iMarker := map.AddMarker(map.Places.Results[i].latitude,map.Places.Results[i].longitude);

      if iMarker>-1 then
      begin

        if pos('restaurant',types)>0 then
         icon :=  'http://google-maps-icons.googlecode.com/files/restaurant.png'
        else
        if pos('doctor',types)>0 then
         icon := 'http://google-maps-icons.googlecode.com/files/doctor.png'
        else
         icon := 'http://google-maps-icons.googlecode.com/files/supermarket.png';

   //       map.Markers[iMarker].setImage(icon,Point(32,37),Point(0,0),Point(16,37));
        map.Markers[iMarker].Clickable := true;
        map.Markers[iMarker].icon       := icon;
        map.Markers[iMarker].tag        := FStartPlace+place.items.add(names);
      //  map.Markers[iMarker].IconSize   := Point(37,32);
        map.Markers[iMarker].infoWindow := map.InfoWindows.Add(names);
        map.InfoWindows[map.Markers[iMarker].infoWindow].Anchor :=   iMarker;

      end;

    end;




  Place.items.EndUpdate;


  map.Polygones.clear;
 map.Polygones.Add;
  map.Polygones[0].Color := clBlue;
  map.Polygones[0].FillColor := clBlue;
  map.Polygones[0].fillOpacity   := 0.4;
  map.Polygones[0].fillOpacity   := 0.3;
  map.Polygones[0].Add(map.places.LatSW,map.places.lngSW);
  map.Polygones[0].Add(map.places.LatSW,map.places.lngNE);
  map.Polygones[0].Add(map.places.LatNE,map.places.lngNE);
  map.Polygones[0].Add(map.places.LatNE,map.places.lngSW);
  map.Polygones[0].Add(map.places.LatSW,map.places.lngSW);
  map.Polygones[0].Clickable := false;
  
  doShowPlaces(0);
end;

procedure TFDemoLocalise.osmClick(Sender: TObject);
begin
 //map.places.useOSM := osm.checked;
 map.useOpenMapQuestServices := osm.checked;
end;

procedure TFDemoLocalise.doClearPlaces;
begin


 doCloseInfoWindows;

 map.Clear;
 

 doClearGrids;




 map.Markers[map.AddMarker(map.Latitude,map.longitude)].Draggable := true;
 map.Markers[0].icon := 'http://maps.google.com/mapfiles/ms/micons/red-pushpin.png';
 // link infowindow width marker
 map.InfoWindows[map.InfoWindows.Add('')].Anchor := 0;
end;

procedure TFDemoLocalise.doClearGrids;
begin
 Place.items.clear;
 Place.text := '';

 Results.RowCount   := 2;
 Results.Cells[0,1] := '';
 Results.Cells[1,1] := '';

 Details.RowCount   := 2;
 Details.Cells[0,1] := '';
 Details.Cells[1,1] := '';
end;

procedure TFDemoLocalise.btClearClick(Sender: TObject);
begin
 doClearPlaces;
end;


procedure TFDemoLocalise.Panel4Resize(Sender: TObject);
begin
 results.ColWidths[0] := results.Width div 3;
 results.ColWidths[1] := results.Width-results.ColWidths[0];

 if (GetWindowlong(results.Handle, GWL_STYLE) and WS_VSCROLL) <> 0 then
  results.ColWidths[1] := results.ColWidths[1] - GetSystemMetrics(SM_CYVSCROLL);

 Details.ColWidths[0] := results.ColWidths[0];
 Details.ColWidths[1] := details.Width-details.ColWidths[0];

 if (GetWindowlong(details.Handle, GWL_STYLE) and WS_VSCROLL) <> 0 then
  details.ColWidths[1] := details.ColWidths[1] - GetSystemMetrics(SM_CYVSCROLL);
end;

procedure TFDemoLocalise.placeClick(Sender: TObject);
begin
 doShowPlaces(place.itemindex);
end;

procedure TFDemoLocalise.doShowPlaces(const idPlace:integer);
var j:integer;
    PlaceResult : TECPlaceResult;
    Marker      : TECMapMarker;
begin

 if (idPlace<0) then exit;

 Place.itemIndex := idPlace;


 PlaceResult := map.Places.Results[idPlace];

 if (PlaceResult=nil) then exit;


 if PlaceResult.countResult>0 then
 begin
  results.RowCount := 1 + PlaceResult.countResult;

  for j:=0 to PlaceResult.countResult-1 do
  begin

    results.cells[0,1+j] := PlaceResult.NameResult[j];
    results.cells[1,1+j] := PlaceResult.Result[PlaceResult.NameResult[j]];

  end;

 end

 else

 begin
  Results.RowCount := 2;
  Results.Cells[0,1] := '';
  Results.Cells[1,1] := '';
 end;




 if PlaceResult.countDetail>0 then
 begin
   details.RowCount := 1 + PlaceResult.countDetail;

   for j:=0 to PlaceResult.countDetail-1 do
   begin

     details.cells[0,1+j] := PlaceResult.NameDetail[j];
     details.cells[1,1+j] := PlaceResult.Detail[PlaceResult.NameDetail[j]];

   end;
 end

 else

 begin
  Details.RowCount := 2;
  Details.Cells[0,1] := '';
  Details.Cells[1,1] := '';
 end;



 doCloseInfoWindows;

 Marker := map.Markers[1+FStartPlace+idPlace];

 if assigned(Marker) and assigned(map.InfoWindows[Marker.infoWindow]) then
 begin
   Marker.PanTo;
   map.InfoWindows[Marker.infoWindow].open := true;

 end;


end;

procedure TFDemoLocalise.mapMarkerClick(sender: TObject; const Index: Integer;
  const dLatitude, dLongitude: Double);
begin



 if (index>0) and (map.markers[Index].tag>=FStartPlace) then
   doShowPlaces(map.markers[Index].tag-FStartPlace)
 else
 begin
 // map.markers[Index].Draggable := true;
 end;

end;

procedure TFDemoLocalise.radiusChange(Sender: TObject);
begin
 btFindPlaces.enabled := (radius.text<>'') and not map.Places.searching;
end;



procedure TFDemoLocalise.mapPlacesDetail(Sender: TObject);
begin
  doShowPlaces(place.itemindex);
end;

procedure TFDemoLocalise.btDetailsClick(Sender: TObject);
begin
  if (map.Places.Results[place.itemindex]=nil) then exit;

  map.Places.Results[place.itemindex].getDetails;
end;


procedure TFDemoLocalise.resultsDrawCell(Sender: TObject; aCol,
  aRow: Integer; Rect: TRect; State: TGridDrawState);
begin
 With Sender As TStringGrid Do With Canvas Do
  Begin

   Canvas.Font.Name := 'Tahoma';
   Canvas.Font.size := 8;

    If (ACol=0) or  (gdFixed in State) then 
      Brush.Color := clBtnFace
    Else If gdSelected In State Then
            Brush.Color := clNavy
          Else Brush.Color := clWhite;


    FillRect(Rect);


    Pen.Color := cl3DLight;

  Pen.width := 1;

  Moveto(rect.left,rect.bottom-1);
  Lineto(rect.right-1,rect.bottom-1);
  LineTo(rect.right-1,rect.top-1);


    if (ACol=0)or(ARow=0) then
     Canvas.Font.Style := [fsBold]
    else
     Canvas.font.Style := [];

    If (gdSelected In State) and (ACol>0) Then
      SetTextColor(Canvas.Handle,clWhite)
    Else SetTextColor(Canvas.Handle,clBlack);

    if (ACol=0)or(ARow=0) then

     DrawText(Canvas.Handle, PChar(Cells[aCol,aRow]), -1, Rect ,
              DT_CENTER or DT_VCENTER or DT_NOPREFIX or DT_SINGLELINE )

    else
     begin
      rect.top   := rect.top + 4;
      rect.left  := rect.left + 2;
      rect.Right := rect.right - 2;
      DrawText(Canvas.Handle, PChar(Cells[aCol,aRow]), -1, rect ,
              DT_CENTER or DT_NOPREFIX or DT_WORDBREAK ) ;
     end;




  End;
end;

procedure TFDemoLocalise.mapBeforeChangeMapApi(Sender: TObject);
begin
 doClearPlaces;
end;



procedure TFDemoLocalise.mapAdress(sender: TObject; const sAdresses: string;
  var Index: Integer);
begin
 map.Markers[0].setPosition(map.Adresses.Latitude[0],map.Adresses.Longitude[0]);
end;

procedure TFDemoLocalise.mapAfterChangeMapApi(Sender: TObject);
begin
 Cartes.Items.Text := map.MapTypes.Text;
 pnDetail.visible  := map.MapAPI = apiGoogle;

end;

procedure TFDemoLocalise.mapAfterReload(Sender: TObject);
begin
 mapPlacesSearch(self);
end;

end.
