unit UMainMobile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, ECMaps, ExtCtrls, OleCtrls, SHDocVw;

type
  TFDemoMobile = class(TForm)
    pnOptions: TPanel;
    map: TECMap;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    RouteGroup: TPanel;
    RoutePanel: TPanel;
    PanelStartEnd: TPanel;
    cbStart: TComboBox;
    lbstart: TLabel;
    Label1: TLabel;
    cbDestination: TComboBox;
    Colordialog: TColorDialog;
    Panel1: TPanel;
    speedLoadMap: TSpeedButton;
    SpeedSaveMap: TSpeedButton;
    routes: TComboBox;
    pntrip: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel13: TPanel;
    WebBrowser: TWebBrowser;
    pnStreetView: TPanel;
    mapStreet: TECMap;
    MobileKM: TPanel;
    RouteAdd: TButton;
    lbCarte: TLabel;
    cbCarte: TComboBox;
    speed: TLabel;
    TimerSpeed: TTimer;
    ck3D: TCheckBox;
    procedure speedLoadMapClick(Sender: TObject);
    procedure SpeedSaveMapClick(Sender: TObject);
    procedure cbStartKeyPress(Sender: TObject; var Key: Char);

    procedure RouteAddClick(Sender: TObject);
    
    procedure routesChange(Sender: TObject);

    procedure Panel1Resize(Sender: TObject);
    
    procedure mapRouteError(sender: TObject; const idRoute: Integer;
      const sError: String);
    procedure cbStartChange(Sender: TObject);
    procedure mapStreetLoad(Sender: TObject);
    procedure mapRouteChange(sender: TObject; const idRoute: Integer;const NewRoute:boolean);
    procedure mapMarkerMove(sender: TObject; const Index: Integer;
      var dLatitude, dLongitude: Double);
    procedure mapLoad(Sender: TObject);
    procedure mapEndMobile(sender: TObject; const iMobile: Integer);
    procedure mapStepMobile(sender: TObject; const iMobile,
      iStep: Integer);
    procedure mapBeforeChangeToTxt(Sender: TObject);
    procedure mapAfterChangeToTxt(Sender: TObject);
    procedure mapMapIdle(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbCarteChange(Sender: TObject);
    procedure cbStartClick(Sender: TObject);
    procedure mapStreetMapClick(sender: TObject; const dLatitude,
      dLongitude: Double);
    procedure lbstartClick(Sender: TObject);
    procedure mapGeoLocation(sender: TObject; const dLatitude,
      dLongitude: Double; const sAdresse: string);
    procedure TimerSpeedTimer(Sender: TObject);
    procedure ck3DClick(Sender: TObject);
    procedure mapEarthViewShow(Sender: TObject);
    procedure Panel1Click(Sender: TObject);


  private
    { Dclarations prives }
   FComboQueryAdress : TComboBox;

   FLastLat,FLastLng : double;
   FLastPositionKM   : double;

   idMarker : integer;

   procedure doShowDataRoute(const id:integer);
   procedure doUpdateMobileDistance(const idMobile:integer);

   function  SelectLatLng(const cb : TComboBox;var Lat,Lng:double):boolean;
   
  public
    { Dclarations publiques }
  end;

var
  FDemoMobile: TFDemoMobile;

implementation

{$R *.DFM}

uses UECMapUtil;


const HTML_BODY_TEMPLATE = '<html><style type="text/css">'+
          'body{ background: #fff;font: 12pt verdana;color: #111;overflow-x:hidden;'+
	               'margin : 0;'+
                 'border-style :none;'+
               '}'+
          'div {margin:0;padding:5px;width:100%;overflow-x:hidden}'+
          '.km {margin:0;color:#4FB2FF;font-size:x-small; text-align:right}'+
          '.odd{background: #eee;color: #000000;}'+
          '</style><body>';





procedure TFDemoMobile.Panel1Click(Sender: TObject);
begin
 mapstreet.reload;
end;

procedure TFDemoMobile.Panel1Resize(Sender: TObject);
begin
 routes.width  := lbCarte.left - 7 - routes.left;
 cbCarte.width := panel1.width - 7 - cbCarte.left;
end;


procedure TFDemoMobile.cbCarteChange(Sender: TObject);
begin
 case cbCarte.itemindex of
   0    :  map.MapApi := apiGoogle;
   1    :  map.MapApi := apiCloudMade;
   2    :  map.MapApi := apiOpenMapQuest;
   3    :  map.MapApi := apiLeaflet;
   4 : map.MapAPI     := apiBing;
 end;
end;

procedure TFDemoMobile.cbStartChange(Sender: TObject);
begin
 RouteAdd.enabled := (cbStart.text<>'') and (cbDestination.text<>'');
end;


function TFDemoMobile.SelectLatLng(const cb : TComboBox;var Lat,Lng:double):boolean;
begin

 result := false;

 if not assigned(cb) then exit;

 if cb.ItemIndex>-1 then
 begin
   if (cb.Tag>-1)and(cb.Tag<map.ListAdresses.count) then
   begin
      Lat := map.ListAdresses[cb.Tag].latitude[cb.ItemIndex];
      Lng := map.ListAdresses[cb.Tag].longitude[cb.ItemIndex];

      result := true;
   end;

 end;

end;

procedure TFDemoMobile.cbStartClick(Sender: TObject);
begin
end;

{*
   Load map
}
procedure TFDemoMobile.speedLoadMapClick(Sender: TObject);
begin
 if OpenDialog.execute then
  map.LoadFromFile(OpenDialog.filename);
end;

{*
  Save map

}
procedure TFDemoMobile.SpeedSaveMapClick(Sender: TObject);
begin
 if SaveDialog.execute then
  map.SaveToFile(SaveDialog.filename);
end;



procedure TFDemoMobile.TimerSpeedTimer(Sender: TObject);
var nKm : double;
begin
  nKm := map.DistanceFrom(FLastLat,FLastLng,map.markers[idMarker].latitude,map.markers[idMarker].longitude);
  Speed.Caption := DoubleToStr(nkm*120)+' K/h';

  FLastLat := map.markers[idMarker].latitude;
  FLastLng := map.markers[idMarker].longitude;

end;

{*
   event OnLoad for mapStreet

   fired when map ok

}
procedure TFDemoMobile.mapStreetLoad(Sender: TObject);
begin

 mapStreet.StreetView.NavigationControl := false;
 mapStreet.StreetView.CloseBtnVisible   := false;
 mapStreet.StreetView.LinkVisible       := false;
 mapStreet.StreetView.Zoom              := 0;
 mapStreet.Zoom                         := 15;

   { we force a redesign so that the properties are taken into account }
 mapStreet.StreetView.ReDraw;
end;



procedure TFDemoMobile.mapStreetMapClick(sender: TObject; const dLatitude,
  dLongitude: Double);
begin

end;

{*
   event OnLoad for map

   fired when map ok

}
procedure TFDemoMobile.mapLoad(Sender: TObject);
begin
 { activate mobiles }
 map.MobilesEnabled := true;
end;





{*
   press RETURN key on combobox start and destination for Geolocalize adress

   fired event OnGeoLocation
}
procedure TFDemoMobile.cbStartKeyPress(Sender: TObject; var Key: Char);
var lat,lng : double;
begin
 if Key=#13 then
 begin
  FComboQueryAdress := Sender As TComboBox;
  if assigned(FComboQueryAdress) then
   map.GeoLocation(FComboQueryAdress.text)  ;
 end;
end;


procedure TFDemoMobile.ck3DClick(Sender: TObject);
begin
 if ck3D.checked then
 begin
  cbCarte.Enabled := false;
  map.mapapi := apiGoogle;
  map.EarthView.Visible := True;
 end else
     begin
       map.EarthView.Visible := false;
       map.fitBoundsRadius(map.markers[idMarker].latitude,map.markers[idMarker].longitude,2); // bounding box 2km around marker
       cbCarte.enabled := true;
       cbCarteChange(nil);
     end;
end;

{*
   event OnGeoLocation

   fired by map.GeoLocation(...)

   @param sender instance of component TECMap
   @param dLatitude  latitude of first response
   @param dLongitude longitude of first response
   @param sAdresse   adresse of first response

}
procedure TFDemoMobile.mapGeoLocation(sender: TObject; const dLatitude,
  dLongitude: Double; const sAdresse: string);
begin
  if assigned(FComboQueryAdress) then
 begin
  FComboQueryAdress.Items.text := map.Adresses.Adresses;
  FComboQueryAdress.ItemIndex  := 0;

  // save all adresses for this query

  if FComboQueryAdress.Tag>-1 then
     map.ListAdresses[FComboQueryAdress.Tag] := map.Adresses
  else
  FComboQueryAdress.Tag := map.ListAdresses.Add(map.Adresses);
 end;

end;


{*
   Add new route
}
procedure TFDemoMobile.RouteAddClick(Sender: TObject);
var lat1,lng1,lat2,lng2 : double;
    title:string;
begin


  // GetLatLngFromAdress fired mapAdress
  // mapAdress fill the combo with adresses
  FComboQueryAdress := cbStart;

  if not SelectLatLng(cbStart,Lat1,Lng1) then

    if not map.GetLatLngFromAdress(cbStart.text,lat1,lng1) then
    begin
      ShowMessage('UNKOWN:'+cbStart.text);
      exit;
    end;



  FComboQueryAdress := cbDestination;

  if not SelectLatLng(cbDestination,Lat2,Lng2) then
    if not map.GetLatLngFromAdress(cbDestination.text,lat2,lng2) then
     begin
      ShowMessage('UNKOWN:'+cbDestination.text);
      exit;
     end;


  Title := cbStart.text+' > '+cbDestination.text;

  FComboQueryAdress := nil;

  routes.itemindex := routes.items.add(Title);

  { is forbidden to add a route so that the future is not calculated
     you will be notified in the event OnRouteChange

     map.routes.ready can also test to see if we can add a route }
  RouteAdd.enabled := false;

  { we add our route on the map }

  map.Routes.Add(title,lat1,lng1,lat2,lng2,false,nil);

  { The last parameter is nil
     because it does not pass through points (waypoints)

    example to add an intermediate point

   wp := TLatLngList.create;
   try
    wp.add(latitude,longitude); // latitude et longitude are double
    map.Routes.Add(titre,lat1,lng1,lat2,lng2,false,wp);
   finally
   wp.free; }

end;



{*
   event OnRouteAdd

   triggered when the road is ready

}
procedure TFDemoMobile.mapRouteChange(sender: TObject;
  const idRoute: Integer;const NewRoute:boolean);

var i,idMobile : integer;
    ok:boolean;

begin

 if not assigned(map.routes[idRoute]) then exit;

 if routes.items.indexof(map.routes[idRoute].name)=-1 then
   routes.items.add(map.routes[idRoute].name);




 { add a mobile on the road only if there is not already,
   there is no limitation but that's just for the demo

   if you load a map with mobiles registered,
   they will be added again when the road will be charged because OnRouteChange is triggered

   Another solution is to disable OnRouteChange in event OnBeforeChangeToString and reactivate in event OnAfterChangeToString

   }
 ok := true;

 for i:=0 to map.mobiles.count-1 do
  if map.mobiles[i].route = idRoute then
  begin
   ok := false;
   break;
  end;

 if ok then
 begin
  { new marker }
   idMarker := map.markers.add(map.routes[idRoute].StartLAtitude,map.routes[idRoute].StartLongitude);
 { change icon }
  map.Markers[idMarker].setImage('http://google-maps-icons.googlecode.com/files/car.png',
                                        Point(32,37),Point(0,0),Point(16,37));
  map.Markers[idMarker].Flat := true;
 //  map.markers[idMarker].icon := 'http://google-maps-icons.googlecode.com/files/car.png';
  { add a mobile marker on this route, speed 90 km/h, start at km 0 }
  idMobile := map.mobiles.add(idMarker,idRoute,90,0);
  map.setCenter(map.markers[idMarker].latitude,map.markers[idMarker].longitude);
   { start mobile }
  map.mobiles[idMobile].mobile := true;
  TimerSpeed.enabled := true;
  FLastPositionKM     := 0;
  FLastLat           := map.markers[idMarker].latitude;
  FLastLng           := map.markers[idMarker].longitude;
 end;



 doShowDataRoute(idRoute);


  // show all route on map
(* map.fitBounds(map.routes[idRoute].SouthWestLatitude,
               map.routes[idRoute].SouthWestLongitude,
               map.routes[idRoute].NorthEastLatitude,
               map.routes[idRoute].NorthEastLongitude);*)

 RouteAdd.enabled := true;
end;







{*
   select new route
}
procedure TFDemoMobile.routesChange(Sender: TObject);
begin
 doShowDataRoute(routes.itemindex);
end;


{*
   update the screen with the properties of the selected route
}
procedure TFDemoMobile.doShowDataRoute(const id:integer);
var i,j:integer;
    s,html:string;
    
    odd:boolean;
begin


 if id<0 then exit;


  cbStart.text       := map.Routes[id].StartAdress;
  cbDestination.text := map.Routes[id].EndAdress;


  routes.itemindex := id ;

  { follow the marker associated with this road}
  map.Mobiles.Tracking := -1;
  for i := 0 to map.Mobiles.count - 1 do
  begin
    if map.Mobiles[i].Route = id then
    begin
      map.Mobiles.Tracking := i ;
      break;
    end;
  end;


  // instructions step by step
  html := HTML_BODY_TEMPLATE;
  odd  := false;
  j    := map.Routes[id].Path.count-1;

  for i:=0 to j do
  begin

    s := map.Routes[id].Path[i].instructions;

    // all steps have no instructions

    if s='' then continue;

    html := html+'<div id="step'+inttostr(i)+'"';

    if odd then html:=html+' class="odd"';

    odd := not odd;

    // distance is in meters, here in km
     html:=html+'>'+s+'<div class="km">'+format('%8.2f km',[map.routes[id].Path[i].distance/1000])+'</div></div>';
  end;

  html := html+'<div ';

   if odd then html:=html+' class="odd"';

   html:=html+'>'+format('Distance : <b>%.2f km</b><br>Estimated time : <b>'+TimeToStr(map.routes[id].duration/24/3600),[map.routes[id].distance/1000])+'</b></div>';


   html := html + '</body></html>';

   // WebBrowserLoadHtml declared in UECMapUtil
   WebBrowserLoadHtml(WebBrowser,html);

 // in this demo idMarker = idRoute
 doUpdateMobileDistance(id);






end;






{*
  event OnRouteError

}
procedure TFDemoMobile.mapRouteError(sender: TObject;
  const idRoute: Integer; const sError: String);
begin

  if not RouteAdd.Enabled then
  begin

   RouteAdd.Enabled     := true;


   WebBrowserLoadHtml(WebBrowser,HTML_BODY_TEMPLATE+'<h1>'+sError+'</h1></body></html>');


   if assigned(map.routes[idRoute]) and
      (map.routes[idRoute].distance = 0) then
   begin
    map.routes.delete(idRoute);
    routes.items.delete(idRoute);
   end;

  end;

end;






procedure TFDemoMobile.mapMapIdle(Sender: TObject);
begin
end;


{*
    event OnMarkerMove

    fired after marker move <br> you can change latitude and longitude in this event

      @param sender instance of component
      @param index index of marker
      @param dLatitude latitude of marker
      @param dLongitude longitude of marker

}
procedure TFDemoMobile.mapMarkerMove(sender: TObject;
  const Index: Integer; var dLatitude, dLongitude: Double);
var idMobile,i : integer;
begin



  idMobile := -1;

  for i:=0 to map.mobiles.count-1 do
   if map.mobiles[i].marker = index then
   begin

    if  map.mobiles[i].route = routes.itemindex then
     idMobile := i;

    break;
   end;



 // if the mobile is for the selected route
 if (idMobile>-1)   then
 begin

  doUpdateMobileDistance(idMobile);


  if  not mapStreet.StreetView.visible then
   mapStreet.StreetView.visible := mapStreet.StreetView.available;

   mapStreet.StreetView.SetPosition(dLatitude,dLongitude);

   mapStreet.StreetView.Heading := map.Mobiles[idMobile].Heading;



 end;


end;



{*
   display the distance traveled,
   update the current stage

}
procedure TFDemoMobile.doUpdateMobileDistance(const idMobile:integer);
begin

 if (not assigned(map.Mobiles[idMobile]))
 or
  (not assigned(map.routes[map.Mobiles[idMobile].route])) then exit;

 { the distance is calculated according to the direction of traveling }
  if map.Mobiles[idMobile].direction = dsStartEnd then
     MobileKm.Caption := DoubleToStr(map.Mobiles[idMobile].distance / 1000)+' Km'
  else
    MobileKm.Caption := DoubleToStr((map.routes[map.Mobiles[idMobile].route].distance - map.Mobiles[idMobile].distance) / 1000)+' Km' ;



end;





procedure TFDemoMobile.FormCreate(Sender: TObject);
begin
 cbStart.Tag       := -1;
 cbDestination.Tag := -1;
 Panel1Resize(nil);
end;

procedure TFDemoMobile.lbstartClick(Sender: TObject);
begin
 MapStreet.Reload;

end;

{*
   event OnEndMobile

   fired when the mobile has arrived
}
procedure TFDemoMobile.mapEarthViewShow(Sender: TObject);
begin

  map.EarthView.Range := 2000; // zoom 2km
  map.EarthView.Clear;
  map.EarthView.ToKml     := Map.toKml;
  map.fitBoundsRadius(map.markers[idMarker].latitude,map.markers[idMarker].longitude,2); // bounding box 2km around marker
  map.EarthView.Altitude := 100;
end;

procedure TFDemoMobile.mapEndMobile(sender: TObject;
  const iMobile: Integer);
begin

   case map.mobiles[iMobile].direction of
    dsStartEnd : map.mobiles[iMobile].direction := dsEndStart;
    dsEndStart : map.mobiles[iMobile].direction := dsStartend;
   end;

   map.mobiles[iMobile].mobile := true;
end;



procedure TFDemoMobile.mapStepMobile(sender: TObject; const iMobile,
  iStep: Integer);
begin
   // WebBrowserExecJS declared in UECMapUtil

  if iMobile = map.Mobiles.Tracking then
   WebBrowserExecJS(WebBrowser,'window.step = "step'+inttostr(map.Mobiles[iMobile].step)+'";'+

                                 'var e=document.getElementById(window.step);'+
                                 'if (e!=null){'+
                                 'e.scrollIntoView(true);' +
                                 'var o = document.getElementById(window.old);'+
                                 'if (o!=null) {o.style.cssText="color:#0";}'+
                                 'e.style.cssText="color:'+ColorToHTML(clGreen)+'";'+
                                 'window.old = window.step;}'
                                );
end;

procedure TFDemoMobile.mapBeforeChangeToTxt(Sender: TObject);
begin
 map.OnRouteChange := nil;  
end;

procedure TFDemoMobile.mapAfterChangeToTxt(Sender: TObject);
var i:integer;
begin
 map.OnRouteChange :=  mapRouteChange;

 routes.Items.clear;

 for i:=0 to map.routes.count-1 do
  routes.items.add(map.routes[i].name);
end;

end.
