unit UMainNativeLinesPolygones;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uecNativeMapControl,uecNativeshape,uecMapUtil, Buttons, ExtCtrls,
  StdCtrls, ComCtrls;

type
  TFormNativeLinePolygone = class(TForm)
    Bar_Menu: TPanel;
    SpeedPolyline: TSpeedButton;
    speedLoadMap: TSpeedButton;
    SpeedSaveMap: TSpeedButton;
    pn_latlng: TPanel;
    Infos: TPanel;
    map: TECNativeMap;
    SpeedPolygone: TSpeedButton;
    noshape: TSpeedButton;
    ColorDialog: TColorDialog;
    pnPolygone: TPanel;
    FillColor: TPanel;
    Label1: TLabel;
    Level: TEdit;
    Label4: TLabel;
    Transparence: TTrackBar;
    Panel1: TPanel;
    ColorBorder: TPanel;
    HoverColor: TPanel;
    pnHelpPoint: TPanel;
    Label2: TLabel;
    pnInfoSize: TPanel;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Label6: TLabel;
    style: TComboBox;
    weight: TEdit;
    Label3: TLabel;
    lbPenStyle: TLabel;
    PenStyle: TComboBox;
    BColor: TPanel;
    BHColor: TPanel;
    Label5: TLabel;
    edtBSize: TEdit;
    procedure mapShapeClick(sender: TObject; const item: TECShape);
    procedure mapMapClick(sender: TObject; const Lat, Lng: Double);
    procedure noshapeClick(Sender: TObject);
    procedure SpeedPolylineClick(Sender: TObject);
    procedure ColorBorderClick(Sender: TObject);
    procedure LevelChange(Sender: TObject);
    procedure TransparenceChange(Sender: TObject);
    procedure speedLoadMapClick(Sender: TObject);
    procedure SpeedSaveMapClick(Sender: TObject);
    procedure styleChange(Sender: TObject);
    procedure weightChange(Sender: TObject);
    procedure PenStyleChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mapMapDblClick(sender: TObject; const Lat, Lng: Double);
    procedure mapResize(Sender: TObject);
    procedure mapLoad(sender: TObject; const GroupName: string;
      const FinishLoading: Boolean);
  
  private
    { Dclarations prives }

    FSelectedShape : TECShape;

    InInfoshape    : boolean;

    procedure Editshape (const Value:boolean);
    procedure doUpdateShape;
    procedure doInfoShape;
    procedure doPathChange(sender : TObject);
  public
    { Dclarations publiques }
  end;

var
  FormNativeLinePolygone: TFormNativeLinePolygone;

implementation

{$R *.dfm}

procedure TFormNativeLinePolygone.mapLoad(sender: TObject;
  const GroupName: string; const FinishLoading: Boolean);
begin
 if assigned(sender) and (sender is TECShapes) then
  TECShapes(sender).fitBounds;
end;

procedure TFormNativeLinePolygone.mapMapClick(sender: TObject; const Lat, Lng: Double);
begin

 if noshape.down then exit;


 if not assigned(FSelectedshape) then
 begin

   if SpeedPolygone.down then
    FSelectedshape := map.add(nsPolygon,Lat,Lng)
   else
    if SpeedPolyline.Down then
    FSelectedshape := map.add(nsLine,Lat,Lng);

  EditShape(true);
  doInfoShape;
  doUpdateShape;



 end else begin

         // if not key CTRL then add point
         if not((GetKeyState(VK_CONTROL) AND 128) = 128)  then
         begin


           if SpeedPolygone.down then

            TECshapePolygone(FSelectedshape).Add(Lat,Lng)
            else
            TECshapeLine(FSelectedshape).Add(Lat,Lng) ;

         end

         else  // if CTRL Pressed then move Shape

           FSelectedshape.SetPosition(lat,lng);

        end;

end;

procedure TFormNativeLinePolygone.mapMapDblClick(sender: TObject; const Lat,
  Lng: Double);
var i,j:integer;
    line1,line2:TECShapeLine;
begin

  j:=0;

  while j<10 do
  begin

  line2 := Map.Shapes.Lines[j];

  if line2.Count>0 then
  begin


  Map.Shapes.Lines.Add(line2.Path[j].latitude,line2.Path[j].longitude);

     line1 := Map.Shapes.Lines[Map.Shapes.Lines.Count-1];


     line1.BeginUpdate;



     line1.Color := clBlack;

     line1.Weight := 15;

     line1.Clickable := True;

     for i := 1 to line2.Count-2 do

     begin

       line1.Add(line2.Path[i].latitude,line2.Path[i].longitude);

     end;


     line1.EndUpdate;
  end;

     inc(j);
  end;
end;

procedure TFormNativeLinePolygone.mapResize(Sender: TObject);
begin
//
end;

procedure TFormNativeLinePolygone.mapShapeClick(sender: TObject; const item: TECShape);
begin

 if assigned(FSelectedshape) and (FSelectedshape is TECshapeLine) then
  TECshapeLine(FSelectedshape).Editable := false;



 FSelectedShape := Item;

 doInfoShape;


 Infos.visible := true;
 pnHelpPoint.visible := true;

 if item is TECShapePolygone then
 begin
  SpeedPolygone.down := true ;
  EditShape(true);
 end
 else
 if item is TECShapeLine then
 begin
  SpeedPolyline.Down := true;
  EditShape(true);
 end
  else
  begin
   Infos.visible := false;
   pnHelpPoint.visible := false;
   Noshape.down := true;
  end;



end;


procedure TFormNativeLinePolygone.noshapeClick(Sender: TObject);
begin
 if noshape.down then
 begin
   EditShape(false);

   FSelectedshape := nil;

   Infos.visible := false;
   pnHelpPoint.visible := false;
 end;

end;

procedure TFormNativeLinePolygone.PenStyleChange(Sender: TObject);
begin
 doUpdateShape;
end;

procedure TFormNativeLinePolygone.speedLoadMapClick(Sender: TObject);
begin
 if OpenDialog.execute then
   map.LoadFromFile(OpenDialog.filename);
end;

procedure TFormNativeLinePolygone.SpeedPolylineClick(Sender: TObject);
begin
  EditShape(false);
  FSelectedshape := nil;
end;


procedure TFormNativeLinePolygone.SpeedSaveMapClick(Sender: TObject);
begin
  if SaveDialog.execute then
  map.SaveToFile(SaveDialog.filename);
end;

procedure TFormNativeLinePolygone.styleChange(Sender: TObject);
begin
 doUpdateShape;
end;

procedure TFormNativeLinePolygone.TransparenceChange(Sender: TObject);
begin
 doUpdateShape;
end;

procedure TFormNativeLinePolygone.weightChange(Sender: TObject);
begin
   doUpdateShape;
end;

procedure TFormNativeLinePolygone.ColorBorderClick(Sender: TObject);
begin
 if ColorDialog.execute then
 begin
  (Sender As TPanel).color := ColorDialog.color;

  doUpdateShape;
 end;
end;


procedure TFormNativeLinePolygone.doPathChange(sender : TObject);
begin


  if sender is TECShapePolygone then

  pnInfoSize.caption := 'Perimeter : '+doubleToStrDigit(TECShapePolygone(sender).Distance,4 )+' Km - Area : '+doubleToStrDigit(TECShapePolygone(sender).Area,4 )+' Km'

  else

  if sender is TECShapeLine then

  pnInfoSize.caption := 'Distance : '+doubleToStrDigit(TECShapeLine(sender).Distance,4 )+' Km' ;


end;

procedure TFormNativeLinePolygone.doUpdateShape;
begin

 if not assigned(FSelectedshape) or InInfoshape then  exit;

 FSelectedshape.color                := ColorBorder.Color;
 FSelectedshape.HoverColor           := HoverColor.Color;
 TECShapeLine(FSelectedshape).Weight := StrToIntDef(weight.text,4);

 TECShapeLine(FSelectedshape).Bordercolor                := BColor.Color;
 TECShapeLine(FSelectedshape).HoverBorderColor           := BHcolor.Color;
 TECShapeLine(FSelectedshape).BorderSize := StrToIntDef(edtBSize.text,0);

 if (penstyle.itemindex>-1) then
     TECShapeLine(FSelectedshape).penstyle := TPenStyle(penstyle.itemindex);


 if FSelectedshape is TECShapePolygone then
 begin

  TECShapePolygone(FSelectedshape).FillColor := FillColor.Color;
  TECShapePolygone(FSelectedShape).FillOpacity   := Transparence.Position;

  if (style.itemindex>-1) then
     TECShapePolygone(FSelectedshape).style := TBrushStyle(style.itemindex);



 end;

 Infos.visible := true;
 pnHelpPoint.visible := true;


end;


procedure TFormNativeLinePolygone.doInfoShape;
begin

 if not assigned(FSelectedshape) then  exit;

 InInfoShape := true;

 ColorBorder.Color  := FSelectedshape.color;
 HoverColor.Color   := FSelectedshape.HoverColor;

 edtbsize.Text :=  IntToStr(TECShapeLine(FSelectedshape).bordersize);

 BColor.Color  := TECShapeLine(FSelectedshape).bordercolor;
 BHColor.Color   := TECShapeLine(FSelectedshape).HoverBorderColor;

 weight.text        := IntToStr(TECShapeLine(FSelectedshape).Weight);


 penstyle.itemindex := integer(TECShapeLine(FSelectedShape).penstyle);


 if FSelectedshape is TECShapePolygone then
 begin

  FillColor.Color       := TECShapePolygone(FSelectedshape).FillColor;
  Level.text            := IntToStr(TECShapePolygone(FSelectedshape).Level);
  Transparence.Position := TECShapePolygone(FSelectedShape).Opacity;
  penstyle.itemindex    := 0;

  style.itemindex       := integer( TECShapePolygone(FSelectedshape).style );


  lbpenstyle.visible := false;
  penstyle.visible   := false;

  edtbsize.visible := false;

  BColor.visible := false;
  BHColor.visible := false;
  Label5.Visible  := false;

 end else begin
           lbpenstyle.visible := true;
           penstyle.visible   := true;
           edtbsize.visible := true;

           BColor.visible := true;
           BHColor.visible := true;
           Label5.Visible  := true;
          end;




 InInfoshape := false;

end;



procedure TFormNativeLinePolygone.Editshape (const Value:boolean);
begin
  if assigned(FSelectedshape) then
 if FSelectedshape is TECShapePolygone then
  TECshapePolygone(FSelectedshape).Editable := value
  else
   TECshapeLine(FSelectedshape).Editable := value;

  if value then
  begin

    pnPolygone.visible :=  FSelectedshape is TECShapePolygone;

    TECshapeLine(FSelectedShape).OnShapePathChange := doPathChange;

    // update infos perimeter / area
    doPathChange(FSelectedShape);


  end;



end;

procedure TFormNativeLinePolygone.FormCreate(Sender: TObject);
begin
  Map.LocalCache     := ExtractFilePath(application.exename) + 'cache';

end;

procedure TFormNativeLinePolygone.LevelChange(Sender: TObject);
begin
 if FSelectedshape is TECShapePolygone then
 begin
  TECshapePolygone(FSelectedshape).Level    := StrToInt(Level.text);
 end;
end;

end.


