unit UMainRoute;

{$I Delphi_Versions.inc}

interface



uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, ECMaps, ExtCtrls, OleCtrls, 
  ComCtrls, TeeProcs, TeEngine, Chart,Series, SHDocVw, VclTee.TeeGDIPlus;

type
  TFDemoRoute = class(TForm)
    pnOptions: TPanel;
    map: TECMap;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    RouteGroup: TPanel;
    RoutePanel: TPanel;
    PanelStartEnd: TPanel;
    RouteHighways: TCheckBox;
    RouteTolls: TCheckBox;
    rbDriving: TRadioButton;
    rbBicycle: TRadioButton;
    rbWalking: TRadioButton;
    GroupBox6: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    RouteColor: TPanel;
    RouteDraggable: TCheckBox;
    RouteTvalue: TSpinEdit;
    RouteEValue: TSpinEdit;
    redraw: TButton;
    GWayPoints: TGroupBox;
    Panel29: TPanel;
    DelWayPoint: TButton;
    AddWayPoint: TButton;
    WayPoints: TListBox;
    cbStart: TComboBox;
    lbstart: TLabel;
    Label1: TLabel;
    cbDestination: TComboBox;
    Panel2: TPanel;
    RouteAdd: TButton;
    RouteUpdate: TButton;
    Colordialog: TColorDialog;
    Panel1: TPanel;
    speedLoadMap: TSpeedButton;
    SpeedSaveMap: TSpeedButton;
    routes: TComboBox;
    OptimizeWayPoints: TButton;
    pcInfo: TPageControl;
    TabTrip: TTabSheet;
    Panel3: TPanel;
    Panel13: TPanel;
    WebBrowser: TWebBrowser;
    Splitter1: TSplitter;
    TabProfil: TTabSheet;
    Chart: TChart;
    pnCalculAltitude: TPanel;
    progressAltitude: TProgressBar;
    Label2: TLabel;
    Panel4: TPanel;
    NextPageElevation: TSpeedButton;
    Panel5: TPanel;
    PrevPageElevation: TSpeedButton;
    Panel6: TPanel;
    btAbortAlt: TButton;
    lbCarte: TLabel;
    cbCarte: TComboBox;
    procedure speedLoadMapClick(Sender: TObject);
    procedure SpeedSaveMapClick(Sender: TObject);
    procedure cbStartKeyPress(Sender: TObject; var Key: Char);
  
    procedure RouteAddClick(Sender: TObject);

    procedure routesChange(Sender: TObject);
    procedure redrawClick(Sender: TObject);
    procedure RouteColorClick(Sender: TObject);
    procedure RouteUpdateClick(Sender: TObject);
    procedure Panel1Resize(Sender: TObject);
    procedure DelWayPointClick(Sender: TObject);
    procedure AddWayPointClick(Sender: TObject);
    procedure mapRouteError(sender: TObject; const idRoute: Integer;
      const sError: String);
    procedure cbStartChange(Sender: TObject);
    procedure OptimizeWayPointsClick(Sender: TObject);
    procedure mapRouteUpdate(sender: TObject; const idRoute: Integer);
    procedure mapBeforeChangeToTxt(Sender: TObject);
    procedure mapAfterChangeToTxt(Sender: TObject);
    procedure mapRouteChange(sender: TObject; const idRoute: Integer;
      const NewRoute: Boolean);
    procedure pcInfoChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel5Resize(Sender: TObject);
    procedure Panel4Resize(Sender: TObject);
    procedure NextPageElevationClick(Sender: TObject);
    procedure PrevPageElevationClick(Sender: TObject);
    procedure ChartClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);



    {$IFDEF D5_OR_HIGHER}
     procedure WebBrowserBeforeNavigate2(Sender: TObject;
       const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    {$ELSE}
       procedure WebBrowserBeforeNavigate2(Sender: TObject;
       pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    {$ENDIF}




    procedure mapMapMove(sender: TObject; const dLatitude, dLongitude: Double);
    procedure mapMapIdle(Sender: TObject);
    procedure btAbortAltClick(Sender: TObject);
    procedure cbCarteChange(Sender: TObject);
    procedure mapGeoLocation(sender: TObject; const dLatitude,
      dLongitude: Double; const sAdresse: string);


  private
    { Dclarations prives }
   FComboQueryAdress : TComboBox;

   idMarker : integer;

   function  SelectLatLng(const cb : TComboBox;var Lat,Lng:double):boolean;

   procedure doShowDataRoute(const id:integer);
   procedure doUpdateDataRoute(const id:integer);
   procedure doUpdateElevation;
   procedure doShowAltitude(const Polyline:TECMapPolyline);
   procedure doOnGetAltitude(Sender:TLatLngList;const Total:integer;var cancel:boolean);
  public
    { Dclarations publiques }
  end;

var
  FDemoRoute: TFDemoRoute;

implementation

{$R *.DFM}

uses UECMapUtil;


const HTML_BODY_TEMPLATE = '<html><style type="text/css">'+
          'body{ background: #fff;color: #000000;overflow-x:hidden;'+
	               'margin : 0;'+
                 'border-style :none;'+
               '}'+
          'div {margin:0;padding:5px;width:100%;overflow-x:hidden}'+
          'div a {text-decoration:none;font: 12pt verdana;color: #111;'+
                 'margin : 0;'+
                 'display:block}'+
          '.km {color:#4FB2FF;font-size:x-small; text-align:right}'+
          '.odd{background: #eee;color: #000000;}'+

          '</style>'+

          '<body>';




procedure TFDemoRoute.Panel1Resize(Sender: TObject);
begin
 routes.width  := lbCarte.left - 7 - routes.left;
 cbCarte.width := panel1.width - 7 - cbCarte.left;
end;


{*
   Load map
}
procedure TFDemoRoute.speedLoadMapClick(Sender: TObject);
begin
 if OpenDialog.execute then
  map.LoadFromFile(OpenDialog.filename);
end;

{*
  Save map

}
procedure TFDemoRoute.SpeedSaveMapClick(Sender: TObject);
begin
 if SaveDialog.execute then
  map.SaveToFile(SaveDialog.filename);
end;



{*
   event OnBeforeNavigate2

   fired when click on trip information list

   url = about:blank#id_item_list_information

}


procedure TFDemoRoute.WebBrowserBeforeNavigate2(Sender: TObject;
  {$IFDEF D5_OR_HIGHER}const{$ENDIF} pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
var i:integer;
    link:string;
begin

 { get only id }
 link := Remplace_Str(url,'about:blank','');
 link := Remplace_str(link,'#','');

 i := SecureStrToInt(link,-1);

 if i<0 then
   exit;

 cancel := true;

 if not assigned(map.Routes[routes.ItemIndex]) then
   exit;


 map.markers[idMarker].setPosition(map.Routes[routes.ItemIndex].Path[i].latitude,
                                   map.Routes[routes.ItemIndex].Path[i].longitude);

 map.markers[idMarker].PanTo;

end;


function TFDemoRoute.SelectLatLng(const cb : TComboBox;var Lat,Lng:double):boolean;
begin

 result := false;

 if not assigned(cb) then exit;

 if cb.ItemIndex>-1 then
 begin
   if (cb.Tag>-1)and(cb.Tag<map.ListAdresses.count) then
   begin
      Lat := map.ListAdresses[cb.Tag].latitude[cb.ItemIndex];
      Lng := map.ListAdresses[cb.Tag].longitude[cb.ItemIndex];

      result := true;
   end;

 end;

end;


{*
   press RETURN key on combobox start and destination for Geolocalize adress

   fired event OnGeoLocation
}
procedure TFDemoRoute.cbStartKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then
 begin
  FComboQueryAdress := Sender As TComboBox;
  if assigned(FComboQueryAdress) then
   map.GeoLocation(FComboQueryAdress.text)  ;
 end;
end;


{*
   event OnGeoLocation

   fired by map.GeoLocation(...)

   @param sender instance of component TECMap
   @param dLatitude  latitude of first response
   @param dLongitude longitude of first response
   @param sAdresse   adresse of first response

}
procedure TFDemoRoute.mapGeoLocation(sender: TObject; const dLatitude,
  dLongitude: Double; const sAdresse: string);
begin
  if assigned(FComboQueryAdress) then
 begin
  FComboQueryAdress.Items.text := map.Adresses.Adresses;
  FComboQueryAdress.ItemIndex  := 0;

  // save all adresses for this query

  if FComboQueryAdress.Tag>-1 then
     map.ListAdresses[FComboQueryAdress.Tag] := map.Adresses
  else
  FComboQueryAdress.Tag := map.ListAdresses.Add(map.Adresses);
 end;

end;





{*
   Add new route
}
procedure TFDemoRoute.RouteAddClick(Sender: TObject);
var lat1,lng1,lat2,lng2 : double;
    title:string;
begin


  // GetLatLngFromAdress fired mapAdress
  // mapAdress fill the combo with adresses
  FComboQueryAdress := cbStart;

  if not SelectLatLng(cbStart,Lat1,Lng1) then
    if not map.GetLatLngFromAdress(cbStart.text,lat1,lng1) then
     begin
      ShowMessage('UNKOWN:'+cbStart.text);
      exit;
     end;



  FComboQueryAdress := cbDestination;

  if not SelectLatLng(cbDestination,Lat2,Lng2) then
   if not map.GetLatLngFromAdress(cbDestination.text,lat2,lng2) then
    begin
      ShowMessage('UNKOWN:'+cbDestination.text);
      exit;
    end;





  if rbWalking.checked then
   map.routes.TravelMode := tmWalking
  else
  if rbBicycle.checked then
   map.routes.TravelMode := tmBicycling
  else
   map.routes.travelMode := tmDriving;


  map.routes.avoidHighways := RouteHighways.checked;
  map.routes.avoidTolls    := RouteTolls.checked;

  map.Routes.draggable     := RouteDraggable.checked;

  map.Routes.color         := RouteColor.Color;
  map.routes.Opacity       := RouteTValue.value / 100;
  map.routes.weight        := RouteEValue.value;

  Title := cbStart.text+' > '+cbDestination.text;



  routes.itemindex := routes.items.add(Title);

  { is forbidden to add a route so that the future is not calculated
     you will be notified in the event OnRouteChange

     map.routes.ready can also test to see if we can add a route }
  RouteAdd.enabled := false;


  FComboQueryAdress := nil;

  { we add our route on the map }

  map.Routes.Add(title,lat1,lng1,lat2,lng2,false,nil);

  { The last parameter is nil
     because it does not pass through points (waypoints)

    example to add an intermediate point

   wp := TLatLngList.create;
   try
    wp.add(latitude,longitude); // latitude et longitude are double
    map.Routes.Add(titre,lat1,lng1,lat2,lng2,wp);
   finally
   wp.free; }


end;








{*
   select new route
}
procedure TFDemoRoute.routesChange(Sender: TObject);
begin
 doShowDataRoute(routes.itemindex);
end;


{*
   update the screen with the properties of the selected route
}
procedure TFDemoRoute.doShowDataRoute(const id:integer);
var i,j,wpcount:integer;
    s,html:string;
    
    odd:boolean;
begin

 RouteUpdate.Enabled := false;


 if id<0 then exit;

 AddWayPoint.Enabled := true;
 DelWayPoint.Enabled := true;
 OptimizeWayPoints.Enabled := true;

  cbStart.text       := map.Routes[id].StartAdress;
  cbDestination.text := map.Routes[id].EndAdress;

  RouteColor.Color   := map.Routes[id].color  ;
  RouteTValue.value  := round(map.routes[id].Opacity * 100);
  RouteEValue.value  := map.routes[id].weight ;

  map.Routes[id].PanToBounds;

  RouteDraggable.checked  := map.Routes[id].Draggable ;


  if map.routes[id].TravelMode = tmBicycling then
   rbbicycle.checked := true
  else
  if map.routes[id].TravelMode = tmWalking then
   rbWalking.checked := true
  else
   rbDriving.checked := true;

  routes.itemindex := id ;




  // instructions step by step
  html := HTML_BODY_TEMPLATE;
  odd  := false;
  j    := map.Routes[id].Path.count-1;

  for i:=0 to j do
  begin

    s := map.Routes[id].Path[i].instructions;

    // all steps have no instructions

    if s='' then continue;

    html := html+'<div id="step'+inttostr(i)+'"';

    if odd then html:=html+' class="odd"';

    odd := not odd;

    // distance is in meters, here in km

   html:=html+'><a href="#'+inttostr(i)+'">'+s+'<div class="km">'+format('%8.2f km',[map.routes[id].Path[i].distance/1000])+'</div></a>'+'</div>';
  end;

  html := html+'<div ';

   if odd then html:=html+' class="odd"';
   odd := not odd;

   html:=html+'>'+format('Distance : <b>%.2f km</b><br>Estimated time : <b>'+TimeToStr(map.routes[id].duration/24/3600),[map.routes[id].distance/1000])+'</b></div>';


   html := html + '</body></html>';

   // WebBrowserLoadHtml declared in UECMapUtil
   WebBrowserLoadHtml(WebBrowser,html);



  // get way points
  wpCount := map.routes[id].waypoints.count;

  DelWayPoint.enabled := wpcount>0;

  AddWayPoint.enabled := wpCount<8;


  WayPoints.Items.BeginUpdate;
  WayPoints.Items.clear;

  for i:=0 to wpCount-1 do
    WayPoints.Items.add(map.routes[id].waypoints.getAdress(i));

  WayPoints.Items.EndUpdate;

 // move marker at start route
 map.Markers[idMarker].setPosition(map.routes[id].StartLatitude,map.routes[id].StartLongitude);
 map.Markers[idMarker].PanTo;

 RouteUpdate.Enabled := true;

 pcInfoChange(nil);

end;




{*
    redraw route
}
procedure TFDemoRoute.redrawClick(Sender: TObject);
begin
 doUpdateDataRoute(routes.itemindex)
end;


{*
  update properties without recalculating the route
}
procedure TFDemoRoute.doUpdateDataRoute(const id:integer);
begin
 if id<0 then exit;

  map.Routes[id].draggable := RouteDraggable.checked;

  map.Routes[id].color     := RouteColor.Color;
  map.routes[id].Opacity   := RouteTValue.value / 100;
  map.routes[id].weight    := RouteEValue.value;


  map.Routes[id]. updateOptions;


end;






{*
   select color
}
procedure TFDemoRoute.RouteColorClick(Sender: TObject);
begin
 if ColorDialog.execute then
    (Sender as TPanel).color := ColorDialog.color;
end;



{*
  recalculate the route

}

procedure TFDemoRoute.RouteUpdateClick(Sender: TObject);
var lat1,lng1,lat2,lng2 : double;

    titre : string;
    id:integer;
begin


  id := routes.itemindex;


  if id<0 then exit;

  FComboQueryAdress := cbStart;


  if not map.GetLatLngFromAdress(cbStart.text,lat1,lng1) then exit;




  FComboQueryAdress := cbDestination;

  if not map.GetLatLngFromAdress(cbDestination.text,lat2,lng2) then exit;


  map.routes[id].StartLatitude  := lat1;
  map.routes[id].StartLongitude := lng1;
  map.routes[id].endLatitude    := lat2;
  map.routes[id].endLongitude   := lng2;



  
 if rbWalking.checked then
   map.routes[id].TravelMode := tmWalking
  else
  if rbBicycle.checked then
   map.routes[id].TravelMode := tmBicycling
  else
   map.routes[id].TravelMode := tmDriving;


  map.routes[id].avoidHighways := RouteHighways.checked;
  map.routes[id].avoidTolls    := RouteTolls.checked;

  map.Routes[id].draggable     := RouteDraggable.checked;

  map.Routes[id].color         := RouteColor.Color;
  map.routes[id].Opacity       := RouteTValue.value / 100;
  map.routes[id].weight        := RouteEValue.value;


  Titre := cbStart.text+' > '+cbDestination.text;

  map.routes[id].name := titre;

  routes.items[id] := map.routes[id].name;


  { we request a recalculation of the route id in light of new properties }
  map.routes[id].update;

  { recalculation of the route is required if we modify :

     map.routes[id].StartLatitude,
     map.routes[id].StartLongitude,
     map.routes[id].endLatitude,
     map.routes[id].endLongitude,
     map.routes[id].WayPoints,
     map.routes[id].TravelMode,
     map.routes[id].avoidHighways et map.routes[id].avoidTolls

 if you just change
     map.Routes[id].draggable,
     map.Routes[id].color ,
     map.routes[id].Opacity et map.routes[id].weight

  you can force a simple redesign of route with

     map.Routes[id]. updateOptions;

   }
end;





{*

 Delete way point

}

procedure TFDemoRoute.DelWayPointClick(Sender: TObject);
var id:integer;
begin
  if WayPoints.itemindex<0 then exit;

  id := routes.itemindex;

  { if no route exit }
  if id<0 then exit;

  map.routes[id].waypoints.delete(WayPoints.itemindex);
  { recalculate the route for the change to take effect  }
  map.routes[id].update;

end;


{*
  Add way point by adress
}
procedure TFDemoRoute.AddWayPointClick(Sender: TObject);
var adr:string;
    dLat,dLng:double;
    id:integer;
begin

  id := routes.itemindex;

  { if no route exit }
  if id<0 then exit;

  FComboQueryAdress := nil;

  adr := InputBox('Add way point', 'Adress :', '');

  if adr<>'' then
  begin

   if map.GetLatLngFromAdress(adr,dLat,dLng) then
   begin
     map.routes[id].WayPoints.Add(dLat,dLng);

    { recalculate the route for the change to take effect  }
    map.routes[id].update;
   end;

  end;

end;


{*
  event OnRouteError

}
procedure TFDemoRoute.mapRouteError(sender: TObject;
  const idRoute: Integer; const sError: String);
begin

  if not RouteAdd.Enabled then
  begin

   RouteAdd.Enabled     := true;


   WebBrowserLoadHtml(WebBrowser,HTML_BODY_TEMPLATE+'<h1>'+sError+'</h1></body></html>');


   if assigned(map.routes[idRoute]) and
      (map.routes[idRoute].distance = 0) then
   begin
    map.routes.delete(idRoute);
    routes.items.delete(idRoute);
   end;

  end;

end;





procedure TFDemoRoute.cbCarteChange(Sender: TObject);
begin
 case cbCarte.itemindex of
   0    :  map.MapApi := apiGoogle;
   1    :  map.MapApi := apiCloudMade;
   2    :  map.MapApi := apiOpenMapQuest;
 end;
end;

procedure TFDemoRoute.cbStartChange(Sender: TObject);
begin
 RouteAdd.enabled := (cbStart.text<>'') and (cbDestination.text<>'');
end;

procedure TFDemoRoute.OptimizeWayPointsClick(Sender: TObject);
var id:integer;
begin
  id := routes.itemindex;

  { if no route exit }
  if id<0 then exit;

  map.routes[id].OptimizeWayPoints;
end;

procedure TFDemoRoute.mapRouteUpdate(sender: TObject;
  const idRoute: Integer);
begin
 exit;
 
 if routes.items.indexof(map.routes[idRoute].name)=-1 then
   routes.items.add(map.routes[idRoute].name);


 doShowDataRoute(idRoute);

 RouteAdd.enabled := true;
end;


{*
  event OnBeforeChangeToTxt

  fired before map.loadfromfile (also map.toTxt)
}
procedure TFDemoRoute.mapBeforeChangeToTxt(Sender: TObject);
begin
  routes.items.clear;
end;



procedure TFDemoRoute.mapMapIdle(Sender: TObject);
begin
if (map.Markers.Count = 0) then
 begin
  { new marker }
   idMarker := map.markers.add(map.LAtitude,map.Longitude);
  { load new icon }
  map.markers[idMarker].icon := 'http://google-maps-icons.googlecode.com/files/car.png';
  Panel1Resize(nil);
  end;
end;

procedure TFDemoRoute.mapMapMove(sender: TObject; const dLatitude,
  dLongitude: Double);
begin

end;

{*
  event OnAfterChangetoTxt

  fired after map.loadfromfile  (also map.toTxt)
}
procedure TFDemoRoute.mapAfterChangeToTxt(Sender: TObject);
var i:integer;
begin
  for i:=0 to map.routes.count-1 do
   routes.items.add(map.routes[i].name);
end;

procedure TFDemoRoute.mapRouteChange(sender: TObject;
  const idRoute: Integer; const NewRoute: Boolean);
begin
 if routes.items.indexof(map.routes[idRoute].name)=-1 then
   routes.items.add(map.routes[idRoute].name);


 if assigned(map.routes[routes.itemindex]) and (map.routes[routes.itemindex].tag<>-1) then
 begin
  map.Polylines.delete(map.routes[routes.itemindex].tag);
  map.routes[routes.itemindex].tag := -1;
 end;

 doShowDataRoute(idRoute);


 RouteAdd.enabled := true;
end;



{*
   event fired by getAltitudes

   @param Sender TLatLngList
   @param Total number of altitude's point calculated
   @cancel flag for abort calcul
}
procedure TFDemoRoute.doOnGetAltitude(Sender: TLatLngList;const Total:integer;var cancel:boolean);
begin
  ProgressAltitude.Position := total;
  cancel                    := btAbortAlt.tag = -1;
end;

procedure TFDemoRoute.pcInfoChange(Sender: TObject);
begin
  doUpdateElevation;
end;

procedure TFDemoRoute.doUpdateElevation;
var Polyline : TECMapPolyline;

begin
 if pcInfo.ActivePage <> TabProfil then exit;


 if not assigned(map.routes[routes.itemindex]) then exit;

 Application.ProcessMessages;

 Polyline := nil;

 if map.routes[routes.itemindex].tag=-1 then
 begin
   map.routes[routes.itemindex].tag := map.AddPolylineFromRoute(routes.itemindex);

   Polyline := map.Polylines[map.routes[routes.itemindex].tag];

   if assigned(Polyline) then
   begin

     Polyline.Visible:=false;

     ProgressAltitude.min := 0;
     ProgressAltitude.max := Polyline.Path.Count;
     ProgressAltitude.Position := 0;

     btAbortAlt.tag := 0;

     pnCalculAltitude.visible := true;

     Application.ProcessMessages;


     Polyline.Path.getAltitudes(doOnGetAltitude);

     pnCalculAltitude.Visible := false;
   end;
 end

 else

 begin
  Polyline := map.Polylines[map.routes[routes.itemindex].tag];
 end;

 doShowAltitude(Polyline);



 Application.ProcessMessages;

end;


procedure TFDemoRoute.doShowAltitude(const Polyline:TECMapPolyline);
var i : integer;
    Altitude,Km: double;
begin

  if not assigned(Polyline) then
    exit;

  chart.Series[0].clear;
  chart.title.text[0]:='';
  chart.BottomAxis.Automatic := true;

 Chart.Series[0].addXY(Km,Polyline.Path[0].Altitude,'',Polyline.Color);
 km := 0;

 for i:=1 to Polyline.Path.Count-1 do
 begin
  Km := km + map.DistanceFrom(Polyline.Path[i-1].Latitude,Polyline.Path[i-1].Longitude,
                         Polyline.Path[i].Latitude,Polyline.Path[i].Longitude);

  altitude := Polyline.Path[i].Altitude;

  if Altitude<0 then
   Altitude := 0;

  Chart.Series[0].addXY(Km,altitude,'',Polyline.Color);
   
 end;
end;


procedure TFDemoRoute.FormCreate(Sender: TObject);
begin

 cbStart.Tag       := -1;
 cbDestination.Tag := -1;

  with Chart do
  begin
   AddSeries(TAreaSeries.Create(Chart));
   title.text.clear;
   chart.title.text.Add('');
   Legend.Visible     := false;
  end;


  pcInfo.ActivePage := TabTrip;

end;



procedure TFDemoRoute.Panel5Resize(Sender: TObject);
begin
 PrevPageElevation.top := (Panel5.height div 2) - 20;
end;

procedure TFDemoRoute.Panel4Resize(Sender: TObject);
begin
 NextPageElevation.top := (Panel4.height div 2) - 20;
end;

procedure TFDemoRoute.NextPageElevationClick(Sender: TObject);
begin
 chart.Nextpage ;
end;
   
procedure TFDemoRoute.PrevPageElevationClick(Sender: TObject);
begin
 Chart.PreviousPage;
end;

procedure TFDemoRoute.ChartClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Polyline : TECMapPolyline;
begin

 if not assigned(map.routes[routes.itemindex]) then
  exit;

 Polyline := map.Polylines[map.routes[routes.itemindex].tag];

 if not assigned(Polyline) then exit;

 map.markers[idMarker].setPosition(Polyline.Path[ValueIndex].latitude,
                                   Polyline.Path[ValueIndex].longitude);

 map.markers[idMarker].PanTo;


 chart.title.text[0]:=map.adress;
 chart.refresh;
end;



procedure TFDemoRoute.btAbortAltClick(Sender: TObject);
begin
 btAbortAlt.tag := -1;
end;

end.
